#!/usr/bin/perl

$input = "current_MP_proteins.txt";

open (IN, $input) || die "cannot open input file\n";
while ($in = <IN>){
	chomp $in;
	push @dir, $in;
}
close IN;

foreach $file (@dir){
	$protein = substr($file, 0, 4);

	open (PDB, "database_MPs/".$protein."_1bcl.pdb") || print "cannot open PDB file for $file\n";
	open (TMP, ">tmp.pdb") || die "cannot open tmp output file for $file\n";
	while ($in = <PDB>){
		chomp $in;
		next if ($in =~ /^HELIX/ || $in =~ /^SHEET/);
		#write whole PDB file except HELIX and SHEET lines into tmp.pdb
		print TMP "$in\n";
	}
	close PDB;
	close TMP;

#LEAVE OUT FOR NOW!!!
#	print "mv $file ".$dir.$protein."_nodssp_biobcl.pdb\n";
#	system ("mv $file ".$dir.$protein."_nodssp_biobcl.pdb\n");

	#run dssp on tmp.pdb
	print "dssp2 tmp.pdb > tmp.dssp\n";
	system ("dssp2 tmp.pdb > tmp.dssp\n");

	#convert dssp output to pdb file tmp1.pdb or dssp.pdb, use -35 to include -3 and -5 options for 3-10 and pi helices
#	print "dssp2pdb -35 tmp.dssp tmp.pdb > database_sol/".$protein."dssp.pdb\n";
#	system ("dssp2pdb -35 tmp.dssp tmp.pdb > database_sol/".$protein."dssp.pdb\n");
	print "dssp2pdb -35 tmp.dssp tmp.pdb > database_MPs/".$protein."_2bcl.pdb\n";
	system ("dssp2pdb -35 tmp.dssp tmp.pdb > database_MPs/".$protein."_2bcl.pdb\n");

	#sorts the helix and sheet lines and writes out biobcl.pdb
#	open (TMP1, "tmp1.pdb") || die "cannot open tmp1 PDB file for $file\n";
#	open (OUT, ">".$dir.$protein."biobcl.pdb") || die "cannot open out PDB file for $file\n";
#	$write_flag = "no";
#	my @helices;
#	my @sheets;
#	while ($in = <TMP1>){
#		chomp $in;

#		if ($in =~ /^HELIX/){
#			push @helices, $in;
#		}
#		elsif ($in =~ /^SHEET/){
#			push @sheets, $in;
#		}
#		elsif ($in =~ /^ATOM/ && $write_flag eq "no") {
#			foreach $helix (@helices){
#				print OUT "$helix\n";
#			}
#			foreach $sheet (@sheets){
#				print OUT "$sheet\n";
#			}
#			$write_flag = "yes";
#			print OUT "$in\n";
#		}
#		else {
#			print OUT "$in\n";
#		}
#	}
#	close OUT;
#	close TMP1;

#print "=====$protein done=====database_sol/".$protein."dssp.pdb written\n";
print "=====$protein done=====database_MPs/".$protein."_2bcl.pdb written\n";

}


