#!/usr/bin/perl

$protein1 = $ARGV[0];	#5-letter code
$protein2 = $ARGV[1];	#5-letter code
$thread   = $ARGV[2];

#print "removing old scripts\n";
#system ("rm alignment_scripts/tmp_".$protein1."_".$protein2.".txt\n");
#system ("rm alignments/".$protein1."_".$protein2.".pir\n");
#system ("rm bcl_align.stdout_".$protein1."_".$protein2.".txt");

$identity = 0.0;
$pam100 = 0.0;
$pam120 = 0.0;
$pam160 = 0.0;
$pam250 = 1;
$blosum90 = 0.0;
$blosum80 = 0.0;
$blosum62 = 0.0;
$blosum45 = 1;
$blast = 1.000;
$psipred = 1.000;
$jufo = 0.341;
$sam = 0.029;
$chemprop = 0.010;

$tfe_white = 0.0;
$tfe_engelman = 0.0;
$phat85 = 0.0;
$phat80 = 0.0;
$phat75 = 0.0;
$phat70 = 0.0;
$tmhmm = 0.0;
$tmmod = 0.0;
$conpred = 0.0;
$proftmb = 0.0;
$b2tmpred = 0.0;

$open_gap = -0.672;
$extend_gap = -0.907;
$open_boundary = -0.635;
$extend_boundary = 0.000;

print "assembling command\n";

#$bcl_command = "/blue/meilerlab/apps/Linux2/x86_64/bcl/2.3.1/bin/bcl-apps-static.exe Alignment ";
#$bcl_command = "/blue/meilerlab/apps/Linux2/x86_64/bcl/current/bin/bcl.exe Alignment ";
$bcl_command = "bcl2011-12-14.exe Alignment ";
$bcl_command .= "-fastas database_MPs/".$protein1.".fasta database_MPs/".$protein2.".fasta ";
$bcl_command .= "-outputprefix alignments/".$protein1."_".$protein2." ";
$bcl_command .= "-outputformat pir ";
$bcl_command .= "-identity $identity ";
$bcl_command .= "-pam100 $pam100 ";
$bcl_command .= "-pam120 $pam120 ";
$bcl_command .= "-pam160 $pam160 ";
$bcl_command .= "-pam250 $pam250 ";
$bcl_command .= "-blosum90 $blosum90 ";
$bcl_command .= "-blosum80 $blosum80 ";
$bcl_command .= "-blosum62 $blosum62 ";
$bcl_command .= "-blosum45 $blosum45 ";
$bcl_command .= "-blast $blast ";
$bcl_command .= "-psipred $psipred ";
$bcl_command .= "-jufo $jufo ";
#print TMP "\#	-sam $sam ";
$bcl_command .= "-steric $chemprop ";
$bcl_command .= "-polarizability $chemprop ";
$bcl_command .= "-volume $chemprop ";
$bcl_command .= "-hydrophobicity $chemprop ";
$bcl_command .= "-isoelectric $chemprop ";
$bcl_command .= "-tfe_white $tfe_white ";
$bcl_command .= "-tfe_engelman $tfe_engelman ";
$bcl_command .= "-phat85 $phat85 ";
$bcl_command .= "-phat80 $phat80 ";
$bcl_command .= "-phat75 $phat75 ";
$bcl_command .= "-phat70 $phat70 ";
#print TMP "\#	-tmhmm $tmhmm ";
#print TMP "\#	-tmmod $tmmod ";
#print TMP "\#	-conpred $conpred ";
#print TMP "\#	-proftmb $proftmb ";
#print TMP "\#	-b2tmpred $b2tmpred ";
$bcl_command .= "-open_gap $open_gap ";
$bcl_command .= "-extend_gap $extend_gap ";
$bcl_command .= "-open_boundary_gap $open_boundary ";
$bcl_command .= "-extend_boundary_gap $extend_boundary \n";
#$bcl_command .= "> bcl_align.stdout_".$protein1."_".$protein2.".txt \n";

#execute bcl alignment command
print "running $bcl_command\n";
system ($bcl_command);
print "BCL::Align done...\n";

open (IN, "alignments/".$protein1."_".$protein2.".pir") || print "died in 022: cannot open alignments/".$protein1."_".$protein2.".pir\n";
$lc = 0;
while ($in = <IN>){
	chomp $in;
	$lc++;
	if ($in =~ /^>/){
		$seq_count++;
		$lc = 0;
	}
	if ($seq_count == 1 && $lc >= 2){
		$template .= $in;
	}
	elsif ($seq_count == 2 && $lc >= 2){
		$query .= $in;
	}
}
close IN;
#print "$query\n";

@template = split //, $template;
@query = split //, $query;

pop @template;
pop @query;

foreach $i (0..$#template){
	if ($query[$i] ne "-" && $template[$i] ne "-"){
		$seq_length++;
		if ($template[$i] eq $query[$i]){
			$identical++;
		}
	}
}

$seqid = sprintf "%.1f", ($identical / $seq_length * 100);

open (OUT, ">>alignments_MPvsMP.txt".$thread) || die "cannot open output file seqids_from_bclAlign.txt".$thread."\n";
#open (OUT, ">>seqids_files_MPvsMPseq/seqids_from_bclAlign_MPseq.txt".$thread) || die "cannot open output file seqids_from_bclAlign.txt".$thread."\n";
print OUT "$protein1\t$protein2\t$identical\t$seq_length\t$seqid\n";
close OUT;

#system ("rm alignment_scripts/tmp_".$protein1."_".$protein2.".txt\n");
#system ("rm alignments/".$protein1."_".$protein2.".pir\n");
#system ("rm bcl_align.stdout_".$protein1."_".$protein2.".txt");

#1a0sP 3mk7B
