#!/usr/bin/perl 

$chains_file = "similar_sequences_despite_pisces_chains.ls";	#all chains

$input = "similar_sequences_despite_pisces_seqids.ls";	#fasta1. fasta2. score - starts out with high score which is high similarity

$output = "clustering_matrix_MP_seqids.txt";

#get the sorted chains for the matrix
open (CHAINS, $chains_file) || die "cannot open $chains_file\n";
while ($in = <CHAINS>){
	chomp $in;
#	push @chains, lc(substr($in, 0, 4)).substr($in, 4, 1);	#crucial for success!!! :o)
	push @chains, $in;
}
close CHAINS;



$cnt = 0;
open (IN, $input) || die "cannot open input file\n";
while($in = <IN>){
	chomp $in;
	$cnt++;
	@in = split /\s+/, $in;
	$cnt % 100000 == 0 ? print "$cnt\n" : print "";
	$element1 = $element2 = ($#chains+1);
	$pdb1 = $in[0];
	$pdb2 = $in[1];
#	$pdb1 = substr($in[0], 0, 4).substr($in[0], 8, 1);
#	$pdb2 = substr($in[1], 0, 4).substr($in[1], 8, 1);

	foreach $i (0..$#chains){
		$chains[$i] eq $pdb1 ? $element1 = $i : print "";
		$chains[$i] eq $pdb2 ? $element2 = $i : print "";
	}
	if ($in[2] ne "nan"){
#		$matrix[$element1][$element2] = sprintf "%.6f", ($in[2] + 5); #offset: +3 for MPs, +5 for soluble proteins for MAMMOTH
		$matrix[$element1][$element2] = sprintf "%.6f", $in[2]; #no offset for seqids from bclAlign
	}
	else {
		$matrix[$element1][$element2] = sprintf "%.6f", 0;
		print "$element1, $element2 is set to zero\n";
	}
}
close IN;

open (OUT, ">".$output) || die "cannot open output file\n";
print OUT "bcl::storage::Table<double>\t";
foreach $i (0..$#chains){
	print OUT "$chains[$i]\t";
}
print OUT "\n";

foreach $i (0..$#chains){
	print OUT "$chains[$i]\t";
	foreach $j (0..$#chains){
#		if ($matrix[$i][$j] >= 80 && $i != $j){
#			print "$chains[$i]\t$chains[$j]\t$matrix[$i][$j]\n";
#		}

		if ($matrix[$i][$j] < $matrix[$j][$i]){
			$min_cross = $matrix[$i][$j];
			$max_cross = $matrix[$j][$i];
		} 
		else {
			$min_cross = $matrix[$j][$i];
			$max_cross = $matrix[$i][$j];
		}

		if ($matrix[$i][$i] < $matrix[$j][$j]){
			$max_self = $matrix[$j][$j];
			$min_self = $matrix[$i][$i];
		} 
		else {
			$max_self = $matrix[$i][$i];
			$min_self = $matrix[$j][$j];
		}
		$score = sprintf "%.2f", $min_cross;
#		$score = sprintf "%.4f", ($min_cross / $max_self);
#		print "$chains[$i]\t$chains[$j]\t$matrix[$i][$j]\t$matrix[$j][$i]\t$matrix[$i][$i]\t$matrix[$j][$j]\t$min_cross\t$max_self\t$score\n";
		print OUT "$score\t";
	}
	print OUT "\n";
}
close OUT;
