#!/usr/bin/perl

$file  = "clustering_MP_seqids.Rows.out";		#the clustering*Rows.out file
$cutoff = $ARGV[0];
$tag = "MP_seqids";

#get the clusters without the nan's
open (IN, $file) || die "cannot open input file $file\n";
$flag = 0;
while ($in = <IN>){
	chomp $in;
	if ($in =~ /NODE/){
		@in = split /\s+/, $in;
		push @cluster, $in[1];
		$in[5] eq "nan" ? push @girth, 100 : push @girth, $in[5];
#		$flag = 0;
	}
	else {
		push @member, $in;
#		$flag = 1;
	}
#	if ($girth[-1] eq "nan" && $flag == 1){
#		pop @girth;
#		pop @cluster;
#		pop @member;
#		$flag = 0;
#	}
}
close IN;

#print out the clusters without nan's in temp file
open (TMP, ">tmp") || die "cannot open output file tmp\n";
foreach $i (0..$#cluster){
	print TMP "$cluster[$i]\t$girth[$i]\t$member[$i]\n";
}
close TMP;

#apply cutoff, sort the clusters with girth higher than cutoff by girth and write into 2nd temp file
system ("sort -nk2 tmp | awk '\{if\(\$2>=$cutoff\) print\}' > tmp1\n");

#read the 2nd temp file with the clusters sorted by girth
open (TMP1, "tmp1") || die "cannot open input file tmp1\n";
while ($in = <TMP1>){
	chomp $in;
	@in = split /\s+/, $in;
	push @new_cluster, $in[0];
	push @new_girth, $in[1];
	push @new_member, $in[2];
}
close TMP1;

#remove the subclusters of a cluster by comparing the members of a cluster with the members of the other clusters, so end up with the largest clusters
foreach $i (0..$#new_member){
	foreach $j ($i..$#new_member){
		#if a protein is contained in a subcluster which has a different cluster number
		if ($new_member[$i] eq $new_member[$j] && $new_cluster[$i] != $new_cluster[$j]){
			#print "$i\t$j\t$new_cluster[$i]\t$new_cluster[$j]\t$new_member[$i]\t$new_member[$j]\t$new_girth[$i]\t$new_girth[$j]";
			#remove the cluster with the higher girth, because this is the subcluster => write it in an remove array
			if ($new_girth[$i] > $new_girth[$j]){
				push @remove_cluster, $new_cluster[$i];
				#print "\tremove $new_cluster[$i]\n";
			}
			else {
				push @remove_cluster, $new_cluster[$j];
				#print "\tremove $new_cluster[$j]\n";
			}
		}
	}
}

#sort and remove duplicates in the remove array
%hash = map {$_ => 1} @remove_cluster;
@remove_cluster_sorted = sort keys %hash;
#print "@remove_cluster_sorted\n";

#print the clusters with a girth above the cutoff, print the subclusters with an X at the beginning of the line
open (OUT, ">clusters_".$tag."_".$cutoff.".out") || die "cannot open output file clusters_".$cutoff.".out\n";
foreach $i (0..$#new_cluster){
	$flag = 0;
	foreach $j (0..$#remove_cluster_sorted){
		if ($new_cluster[$i] == $remove_cluster_sorted[$j]){
			print     "X\t"; 
			print OUT "X\t";
			$flag = 1;
		}
	}
#	$new_cluster[$i] != $new_cluster[$i-1] && $flag != 1 ? $cluster_count++ : print "";
	$new_cluster[$i] != $new_cluster[$i-1]? $cluster_count++ : print "";
	print     "$new_cluster[$i]\t$new_girth[$i]\t$new_member[$i]\t$cluster_count\n";
	print OUT "$new_cluster[$i]\t$new_girth[$i]\t$new_member[$i]\t$cluster_count\n";
	$new_cluster[$i] != $new_cluster[$i+1] ? print     "\n" : print "";
	$new_cluster[$i] != $new_cluster[$i+1] ? print OUT "\n" : print "";
}
print "clusters above $cutoff:\t$cluster_count\n";

#remove tmp files
system ("rm tmp tmp1");


