#!/usr/bin/perl 

# Julia Koehler 09/10/09
# this script generates a library of the oligomeric states from a library of biobcl.pdbs
# output is "oligomeric_state_dictionary_*.txt"
# format: 4-letter PDB code
#	  oligomeric state: 0 for monomer, 1 for oligomer
#	  number of subunits in complex (be careful, might not be correct for soluble proteins!!!)
# the oligomeric state is taken from the number of chains in the SEQRES lines, but the PDB files have to be biobcl.pdbs!!!


$path_pdb = "/home/koehlej/projects/jufo/039_training_9D/database_all/";

#write the main directories in an array
opendir (DIR, $path_pdb) || die "cannot open $path_pdb\n";
@dir = sort (readdir DIR);
foreach $file (@dir){
	$file =~ /biobcl\.pdb/ ? push @files, $file : print "";
}
closedir DIR;

open (OUT, ">oligomeric_state_dictionary.txt") || die "cannot open output file\n";
foreach $i (0..$#files){
	if ($number_chains == 1){
		$oligo = 0;
	}
	else {
		$oligo = 1;
	}
	if ($i != 0){
		print OUT "$files[$i-1]\t$oligo\t$number_chains\n";
		print "$files[$i-1]\t$oligo\t$number_chains\n";
	}

	open (FILE, $path_pdb.$files[$i]) || "cannot open $path_pdb.$files[$i]\n";
	$number_chains = 0;
	while ($in = <FILE>){
		chomp $in;
		@in = split //, $in;
		$start_chain = $in[7].$in[8].$in[9].$in[10];
		$start_chain =~ s/\s+//g;
		if ($in =~ /^SEQRES/){
			$start_chain == "1" ? $number_chains++ : print "";
		}
	}
	close FILE;
}
$number_chains == 1 ? $oligo = 0 : $oligo = 1;
print OUT "$files[-1]\t$oligo\t$number_chains\n";
print "$files[-1]\t$oligo\t$number_chains\n";
close OUT;
