#!/usr/bin/perl

#====>
#$path = "/home/koehlej/projects/jufo/021_5fold_X-validation/";
#$input = "network.test";
$input = $ARGV[0];


#read in the data
#=====================================================
open (IN, $input) || die "cannot open input file $input\n";

$region_count = 0;
$ss_count = 0;
$total_counts = 0;
$linecount = 0;
$flag = 0;
while ($in = <IN>){
	chomp $in;
	$linecount++;
	$in =~ s/^\s+//;
	if ($in eq "bcl::linal::Vector<float>"){
		$flag++;
		$linecount=0;
	}
	if ($flag == 1 && $linecount == 2){	#output
		@out = split /\s+/ ,$in;
	}
#print "$linecount\t$flag\t$in\n";
	if ($flag == 2 && $linecount == 2){	#prediction
		@pred = split /\s+/, $in;

		$max_out = 0;
		$max_pred = 0;
		foreach $i (0..8){
			if ($out[$i]  > $max_out){
				$max_out = $out[$i];
				$max_out_element  = $i;
			}
			if ($pred[$i] > $max_pred){
				$max_pred = $pred[$i];
				$max_pred_element = $i;
			}
			
		}
		$counts[$max_out_element][$max_pred_element]++;
		$total_counts++;
		$flag = 0;
	}

}
close IN;

#get the counts from the data
#======================================================
$diagonal_counts = 0;
foreach $i (0..8){		#rows
	foreach $j (0..8){		#columns
		#diagonal and off-diagonal counts (off-diagonal here are with diagonal for now)
		$i == $j ? $diagonal_counts += $counts[$i][$j] : print "";
		$i%3 == $j%3 ? $off_diag_counts += $counts[$i][$j] : print "";

		#for the secondary structure (1st out, 2nd pred)
		($i%3 == 0 && $j%3 == 0) ? $h_h += $counts[$i][$j]:
		($i%3 == 0 && $j%3 == 1) ? $h_s += $counts[$i][$j]:
		($i%3 == 0 && $j%3 == 2) ? $h_c += $counts[$i][$j]:

		($i%3 == 1 && $j%3 == 0) ? $s_h += $counts[$i][$j]:
		($i%3 == 1 && $j%3 == 1) ? $s_s += $counts[$i][$j]:
		($i%3 == 1 && $j%3 == 2) ? $s_c += $counts[$i][$j]:

		($i%3 == 2 && $j%3 == 0) ? $c_h += $counts[$i][$j]:
		($i%3 == 2 && $j%3 == 1) ? $c_s += $counts[$i][$j]:
		($i%3 == 2 && $j%3 == 2) ? $c_c += $counts[$i][$j]: print "";
		
		#for the regions (1st out, 2nd pred)
		($i >= 0 && $i <= 2 && $j >= 0 && $j <= 2) ? $tm_tm   += $counts[$i][$j]:
		($i >= 0 && $i <= 2 && $j >= 3 && $j <= 5) ? $tm_tr   += $counts[$i][$j]:
		($i >= 0 && $i <= 2 && $j >= 6 && $j <= 8) ? $tm_so  += $counts[$i][$j]:

		($i >= 3 && $i <= 5 && $j >= 0 && $j <= 2) ? $tr_tm   += $counts[$i][$j]:
		($i >= 3 && $i <= 5 && $j >= 3 && $j <= 5) ? $tr_tr   += $counts[$i][$j]:
		($i >= 3 && $i <= 5 && $j >= 6 && $j <= 8) ? $tr_so  += $counts[$i][$j]:

		($i >= 6 && $i <= 8 && $j >= 0 && $j <= 2) ? $so_tm  += $counts[$i][$j]:
		($i >= 6 && $i <= 8 && $j >= 3 && $j <= 5) ? $so_tr  += $counts[$i][$j]:
		($i >= 6 && $i <= 8 && $j >= 6 && $j <= 8) ? $so_so += $counts[$i][$j]: print "";

		#take the sum of each row and column
		$sum_row[$i] += $counts[$i][$j];
		$sum_col[$j] += $counts[$i][$j];
	}
}

$off_diag_counts -= $diagonal_counts;

#print "@sum_row\n@sum_col\n\n";

#calculate information gain
foreach $i (0..8){
	foreach $j (0..8){
		$prob = $counts[$i][$j]/$total_counts;
#		$sum_row[$i] /= $total_counts;
#		$sum_col[$j] /= $total_counts;
#print "$sum_row[$i]\n$sum_col[$j]\n\n";
#		$prob != 0 ? $info = $prob * log ($prob)/ log (2) : print "";
#		$prob != 0 ? $info += $prob * log($prob/(1/81))/log 2 : print "";
		$prob != 0 ? $info += $prob * log($prob*$total_counts**2/($sum_row[$i]*$sum_col[$j]))/log 2 : print "";
#print "$counts[$i][$j]\t$prob\t$sum_row[$i]\t$sum_col[$j]\t$info\n";
		
	}
}
#print "\n\n\n$info\n\n\n";

#print the data
#=======================================================
print "\tP\tR\tE\tD\tI\tC\tT\tI\tO\tN\n";
print "OUT\n";
print "\ttm_C\ttr_C\tso_C\t\ttm_E\ttr_E\tso_E\t\ttm_H\ttr_H\tso_H\n";

foreach $i (0..8){
	$i == 0 ? print "tm_C\t" :
	$i == 1 ? print "tr_C\t" :
	$i == 2 ? print "so_C\t" :
	$i == 3 ? print "\n\ntm_E\t" :
	$i == 4 ? print "tr_E\t" :
	$i == 5 ? print "so_E\t" :
	$i == 6 ? print "\n\ntm_H\t" :
	$i == 7 ? print "tr_H\t" :
	$i == 8 ? print "so_H\t": print "";
	foreach $j (0..8){
		$j == 3 || $j == 6 ? print "\t" : print "";
		$counts[$i][$j] == "" ? $counts[$i][$j] = 0 : print "";
		$i == $j ? print "($counts[$i][$j])\t" : print "$counts[$i][$j]\t";
	}
	print "\n";
}

print "============================================================================================";

print "\n\nby secondary structure";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tH\tE\tC\n";
print "H\t$h_h\t$h_s\t$h_c\n";
print "E\t$s_h\t$s_s\t$s_c\n";
print "C\t$c_h\t$c_s\t$c_c\n";
print "--------------------------------------------------------------------------------------------";

$h_h == 0 ? $h_h = 0.0000000001 : print "";
$s_s == 0 ? $s_s = 0.0000000001 : print "";
$c_c == 0 ? $c_c = 0.0000000001 : print "";

print "\n\nnormalized to out";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tH\tE\tC\n";
print "H\t";
printf "%.2f",$h_h/($h_h + $h_s + $h_c)*100;
print "\t";
printf "%.2f", $h_s/($h_h + $h_s + $h_c)*100;
print "\t";
printf "%.2f", $h_c/($h_h + $h_s + $h_c)*100;
print "\nE\t";
printf "%.2f", $s_h/($s_h + $s_s + $s_c)*100;
print "\t";
printf "%.2f", $s_s/($s_h + $s_s + $s_c)*100;
print "\t";
printf "%.2f", $s_c/($s_h + $s_s + $s_c)*100;
print "\nC\t";
printf "%.2f", $c_h/($c_h + $c_s + $c_c)*100;
print "\t";
printf "%.2f", $c_s/($c_h + $c_s + $c_c)*100;
print "\t";
printf "%.2f", $c_c/($c_h + $c_s + $c_c)*100;
print "\n";
print "============================================================================================";

print "\n\nby region";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tso\ttr\ttm\n";
print "so\t$so_so\t$so_tr\t$so_tm\n";
print "tr\t$tr_so\t$tr_tr\t$tr_tm\n";
print "tm\t$tm_so\t$tm_tr\t$tm_tm\n";
print "--------------------------------------------------------------------------------------------";

$tm_tm == 0 ? $tm_tm = 0.0000000001 : print "";
$tr_tr == 0 ? $tr_tr = 0.0000000001 : print "";
$so_so == 0 ? $so_so = 0.0000000001 : print "";

print "\n\nnormalized by out";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tso\ttr\ttm\n";
print "so\t";
printf "%.2f", $so_so/($so_so + $so_tr + $so_tm)*100;
print "\t";
printf "%.2f", $so_tr/($so_so + $so_tr + $so_tm)*100;
print "\t";
printf "%.2f", $so_tm/($so_so + $so_tr + $so_tm)*100;
print "\ntr\t";
printf "%.2f", $tr_so/($tr_so + $tr_tr + $tr_tm)*100;
print "\t";
printf "%.2f", $tr_tr/($tr_so + $tr_tr + $tr_tm)*100;
print "\t";
printf "%.2f", $tr_tm/($tr_so + $tr_tr + $tr_tm)*100;
print "\ntm\t";
printf "%.2f", $tm_so/($tm_so + $tm_tr + $tm_tm)*100;
print "\t";
printf "%.2f", $tm_tr/($tm_so + $tm_tr + $tm_tm)*100;
print "\t";
printf "%.2f", $tm_tm/($tm_so + $tm_tr + $tm_tm)*100;
print "\n";

print "============================================================================================";
print "\n\ntotal counts:\t\t\t\t$total_counts\n\n";
print ">diagonal\t\t(9-state):\t";
printf "%.4f", $diagonal_counts/$total_counts;
print "\n";
#print "off-diagonal:\t";
#printf "%.4f", $off_diag_counts/$total_counts;
#print "\n";
print ">by secondary structure\t(3-state):\t";
printf "%.4f", ($h_h + $s_s + $c_c)/$total_counts;
print "\n";
print ">by TM region\t\t(3-state):\t";
printf "%.4f", ($tm_tm + $tr_tr + $so_so)/$total_counts;
print "\n\n";
print ">mutual information (?):\t\t\t";
printf "%.4f", $info;
print "\n";

