#!/usr/bin/perl

#this script calculates the percent residue accuracies from the counts, not the averages of the averages over an unbalanced dataset, as 057 does!

$file_flag = $ARGV[0];		#for example "MPalpha_TMBETANET"

foreach $ind (1..5){
	$input = "statistics_ds".$ind."_".$file_flag.".dat";

	$flag_nd = 0;
	$lc = 0;
	open (IN, $input) || die "cannot open input file $input\n";
	while (my $in = <IN>){
		chomp $in;
		next if ($in !~ /\w/);
		$lc++;
		@in = split /\s+/, $in;
	
		#get correct method
		$in =~ /$method/ ? $flag_method = 1 : print "";
		$in =~ /METHOD/ && $in !~ /$method/ ? $flag_method = 0 : print "";

		#get 9-state
		$flag_method == 1 && ($in =~ /^9state/ || $in =~ /^sspred/ || $in =~ /^tmpred/ || $in =~ /^TMPred/) ? $flag_nd++ : print "";
		$flag_method == 1 && ($in =~ /^9state/ || $in =~ /^sspred/ || $in =~ /^tmpred/ || $in =~ /^TMPred/) ? $lc=0 : print "";

		#for percentages in 9state, odd $flag_nd for cnts, even $flag_nd for percentages, except for TMH and TMS
		if ($flag_nd == 1 && $lc >= 1 && $lc <= 9){
			foreach $k (1..9){
				if ($in[$k] eq "-"){
					$matrix_9d[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_9d[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for percentages in sspred
		if ($flag_nd == 3 && $lc >= 1 && $lc <= 3){
			foreach $k (1..3){
				if ($in[$k] eq "-"){
					$matrix_ss[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_ss[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for percentages in tmpred
		if ($flag_nd == 5 && $lc >= 1 && $lc <= 3){
			foreach $k (1..3){
				if ($in[$k] eq "-"){
					$matrix_tm[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_tm[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for counts in tmhelix
		if ($flag_nd == 7 && $lc >= 1 && $lc <= 2){
			foreach $k (1..2){
				if ($in[$k] eq "-"){
					$matrix_tmh[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_tmh[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#for counts in tmstrand
		if ($flag_nd == 8 && $lc >= 1 && $lc <= 2){
			foreach $k (1..2){
				if ($in[$k] eq "-"){
					$matrix_tms[$ind][$lc][$k] = 0;
				}
				else {
					$matrix_tms[$ind][$lc][$k] = $in[$k];
				}
			}
		}

		#add pseudo-counts such that divisor unequal to zero
		($matrix_tmh[$ind][1][1] == 0 && $matrix_tmh[$ind][1][2] == 0) ? $matrix_tmh[$ind][1][1] = 0.000001 : print "";
		($matrix_tmh[$ind][2][1] == 0 && $matrix_tmh[$ind][2][2] == 0) ? $matrix_tmh[$ind][2][1] = 0.000001 : print "";
		($matrix_tms[$ind][1][1] == 0 && $matrix_tms[$ind][1][2] == 0) ? $matrix_tms[$ind][1][1] = 0.000001 : print "";
		($matrix_tms[$ind][2][1] == 0 && $matrix_tms[$ind][2][2] == 0) ? $matrix_tms[$ind][2][1] = 0.000001 : print "";

		#get the percentages for the tmhelix and tmstrand elements
		$matrix_tmh_pct[$ind][1][1] = $matrix_tmh[$ind][1][1] / ($matrix_tmh[$ind][1][1] + $matrix_tmh[$ind][1][2]);
		$matrix_tmh_pct[$ind][1][2] = $matrix_tmh[$ind][1][2] / ($matrix_tmh[$ind][1][1] + $matrix_tmh[$ind][1][2]);
		$matrix_tmh_pct[$ind][2][1] = $matrix_tmh[$ind][2][1] / ($matrix_tmh[$ind][2][1] + $matrix_tmh[$ind][2][2]);
		$matrix_tmh_pct[$ind][2][2] = $matrix_tmh[$ind][2][2] / ($matrix_tmh[$ind][2][1] + $matrix_tmh[$ind][2][2]);

		$matrix_tms_pct[$ind][1][1] = $matrix_tms[$ind][1][1] / ($matrix_tms[$ind][1][1] + $matrix_tms[$ind][1][2]);
		$matrix_tms_pct[$ind][1][2] = $matrix_tms[$ind][1][2] / ($matrix_tms[$ind][1][1] + $matrix_tms[$ind][1][2]);
		$matrix_tms_pct[$ind][2][1] = $matrix_tms[$ind][2][1] / ($matrix_tms[$ind][2][1] + $matrix_tms[$ind][2][2]);
		$matrix_tms_pct[$ind][2][2] = $matrix_tms[$ind][2][2] / ($matrix_tms[$ind][2][1] + $matrix_tms[$ind][2][2]);
	}
	close IN;
}
#print "$matrix_tms[1][2][2]\n";

#get sums for matrices
foreach $i (1..5){			#independent datasets
	foreach $j (1..9){		#rows
		foreach $k (1..9){	#columns

			$total[$i]  += $matrix_9d[$i][$j][$k];
		}
	}
}

#get averages for matrices
foreach $i (1..5){			#independent datasets
	foreach $j (1..9){		#rows
		foreach $k (1..9){	#columns

			#only the diagonals
			next unless ($j == $k);
			$avg_matrix_9d[$i]  += $matrix_9d[$i][$j][$k] / $total[$i];
			$avg_matrix_ss[$i]  += $matrix_ss[$i][$j][$k] / $total[$i];
			$avg_matrix_tm[$i]  += $matrix_tm[$i][$j][$k] / $total[$i];
			$avg_matrix_tmh[$i] += $matrix_tmh[$i][$j][$k] / $total[$i];
			$avg_matrix_tms[$i] += $matrix_tms[$i][$j][$k] / $total[$i];
		}
	}
}

#normalize to get average of matrix values
foreach $i (1..5){			#independent datasets

	#for TMH and TMS all four values
	$avg_matrix_tmh_tmh   += 0.2*$matrix_tmh_pct[$i][1][1];
	$avg_matrix_tmh_ntmh  += 0.2*$matrix_tmh_pct[$i][1][2];
	$avg_matrix_ntmh_tmh  += 0.2*$matrix_tmh_pct[$i][2][1];
	$avg_matrix_ntmh_ntmh += 0.2*$matrix_tmh_pct[$i][2][2];

	$avg_matrix_tms_tms   += 0.2*$matrix_tms_pct[$i][1][1];
	$avg_matrix_tms_ntms  += 0.2*$matrix_tms_pct[$i][1][2];
	$avg_matrix_ntms_tms  += 0.2*$matrix_tms_pct[$i][2][1];
	$avg_matrix_ntms_ntms += 0.2*$matrix_tms_pct[$i][2][2];

	#only for diagonals
	$avg_avg_matrix_9d  += 0.2*($avg_matrix_9d[$i]);
	$avg_avg_matrix_ss  += 0.2*($avg_matrix_ss[$i]);
	$avg_avg_matrix_tm  += 0.2*($avg_matrix_tm[$i]);
	$avg_avg_matrix_tmh += 0.2*($avg_matrix_tmh[$i]);
	$avg_avg_matrix_tms += 0.2*($avg_matrix_tms[$i]);
}

#get differences for stdev
foreach $i (1..5){			#independent datasets

	$diff_tmh_tmh   += ($matrix_tmh_pct[$i][1][1] - $avg_matrix_tmh_tmh)**2;
	$diff_tmh_ntmh  += ($matrix_tmh_pct[$i][1][2] - $avg_matrix_tmh_ntmh)**2;
	$diff_ntmh_tmh  += ($matrix_tmh_pct[$i][2][1] - $avg_matrix_ntmh_tmh)**2;
	$diff_ntmh_ntmh += ($matrix_tmh_pct[$i][2][2] - $avg_matrix_ntmh_ntmh)**2;

	$diff_tms_tms   += ($matrix_tms_pct[$i][1][1] - $avg_matrix_tms_tms)**2;
	$diff_tms_ntms  += ($matrix_tms_pct[$i][1][2] - $avg_matrix_tms_ntms)**2;
	$diff_ntms_tms  += ($matrix_tms_pct[$i][2][1] - $avg_matrix_ntms_tms)**2;
	$diff_ntms_ntms += ($matrix_tms_pct[$i][2][2] - $avg_matrix_ntms_ntms)**2;

	#only for diagonals
	$diff_9d  += ($avg_matrix_9d[$i]  - $avg_avg_matrix_9d)**2;
	$diff_ss  += ($avg_matrix_ss[$i]  - $avg_avg_matrix_ss)**2;
	$diff_tm  += ($avg_matrix_tm[$i]  - $avg_avg_matrix_tm)**2;
	$diff_tmh += ($avg_matrix_tmh[$i] - $avg_avg_matrix_tmh)**2;
	$diff_tms += ($avg_matrix_tms[$i] - $avg_avg_matrix_tms)**2;
}

#get avg and stdev
$stdev_tmh_tmh   = sqrt($diff_tmh_tmh / 5);
$stdev_tmh_ntmh  = sqrt($diff_tmh_ntmh / 5);
$stdev_ntmh_tmh  = sqrt($diff_ntmh_tmh / 5);
$stdev_ntmh_ntmh = sqrt($diff_ntmh_ntmh / 5);

$stdev_tms_tms   = sqrt($diff_tms_tms / 5);
$stdev_tms_ntms  = sqrt($diff_tms_ntms / 5);
$stdev_ntms_tms  = sqrt($diff_ntms_tms / 5);
$stdev_ntms_ntms = sqrt($diff_ntms_ntms / 5);

$stdev_9d  = sqrt($diff_9d / 5);
$stdev_ss  = sqrt($diff_ss / 5);
$stdev_tm  = sqrt($diff_tm / 5);
$stdev_tmh = sqrt($diff_tmh / 5);
$stdev_tms = sqrt($diff_tms / 5);

#print avg and stdev for 9d
print "average and stdev of percentage of correctly predicted residues:\n";
print "9state:\t\t";
printf "%5.2f", ($avg_avg_matrix_9d*100);
printf " +/-%5.2f\t", ($stdev_9d*100);
print "\n";

print "SSPred:\t\t";
printf "%5.2f", ($avg_avg_matrix_ss*100);
printf " +/-%5.2f\t", ($stdev_ss*100);
print "\n";

print "TMPred:\t\t";
printf "%5.2f", ($avg_avg_matrix_tm*100);
printf " +/-%5.2f\t", ($stdev_tm*100);
print "\n\n";

print "TMH avg:\t";
printf "%5.2f", ($avg_avg_matrix_tmh*100);
printf " +/-%5.2f\t", ($stdev_tmh*100);
print "\n";

print "TMH-TMH:\t";
printf "%5.2f", ($avg_matrix_tmh_tmh*100);
printf " +/-%5.2f\t", ($stdev_tmh_tmh*100);
print "\n";

print "TMH-nTMH:\t";
printf "%5.2f", ($avg_matrix_tmh_ntmh*100);
printf " +/-%5.2f\t", ($stdev_tmh_ntmh*100);
print "\n";

print "nTMH-TMH:\t";
printf "%5.2f", ($avg_matrix_ntmh_tmh*100);
printf " +/-%5.2f\t", ($stdev_ntmh_tmh*100);
print "\n";

print "nTMH-nTMH:\t";
printf "%5.2f", ($avg_matrix_ntmh_ntmh*100);
printf " +/-%5.2f\t", ($stdev_ntmh_ntmh*100);
print "\n\n";

print "TMS avg:\t";
printf "%5.2f", ($avg_avg_matrix_tms*100);
printf " +/-%5.2f\t", ($stdev_tms*100);
print "\n";

print "TMS-TMS:\t";
printf "%5.2f", ($avg_matrix_tms_tms*100);
printf " +/-%5.2f\t", ($stdev_tms_tms*100);
print "\n";

print "TMS-nTMS:\t";
printf "%5.2f", ($avg_matrix_tms_ntms*100);
printf " +/-%5.2f\t", ($stdev_tms_ntms*100);
print "\n";

print "nTMS-TMS:\t";
printf "%5.2f", ($avg_matrix_ntms_tms*100);
printf " +/-%5.2f\t", ($stdev_ntms_tms*100);
print "\n";

print "nTMS-nTMS:\t";
printf "%5.2f", ($avg_matrix_ntms_ntms*100);
printf " +/-%5.2f\t", ($stdev_ntms_ntms*100);
print "\n";
