#!/usr/bin/perl

$path = "/home/koehlej/projects/jufo/039_training_9D/";
#$i = $ARGV[0];		#independent dataset, 0..4
$listfile = $ARGV[0];

#go through each independent dataset
#foreach $i (0..4){
#	$listfile = "dataset".($i+1).".ls";
#	$listfile = "dataset".($i+1)."_MP.ls";
#	$listfile = "missing_jufo.ls";
#	$listfile = "fun";
	@pdblist = ();

	#write proteins from listfile into array
	open (LIST, $listfile) || die "cannot open PDB file $listfile\n";
	while (my $in = <LIST>){
		chomp $in;
		@in = split /\s+/, $in;
#		next unless ($in[1] =~ /Membrane/);
		push @pdblist, $in[0];
		push @index, $in[1];
	}
	close LIST;

	#go through protein array
	foreach $j (0..$#pdblist){
		$i = $index[$j];
#		next unless ($pdblist[$j] eq "1a91A");
#		next unless ($pdblist[$j] eq "3zuxA");

		#print new listfile with single protein chain for executable to run
		open (OUT, ">examples/".$pdblist[$j].".ls") || die "cannot open output list file $pdblist[$j]\n";
		print OUT "$pdblist[$j]\tMembrane\n";
		close OUT;
		print "=== list file written: examples/".$pdblist[$j].".ls\n";

		#create input file for ANNs
		print "\n\n===executing apps_release2012-01-03.exe GenerateJufoDescription -pdb_list examples/".$pdblist[$j].".ls -path examples/ -oligo_dict oligomeric_state_dictionary.txt -membrane_orientation_path examples/ -output_prefix examples/".$pdblist[$j]."_".($i+1).".tmp -creating_input_for_first_layer -window_radius 15 -creating_unbalanced_input -creating_nonrandom_input -membrane 11.25 12.5 0 -creating_input_for_testing\n\n";
		system ("\n\napps_release2012-01-03.exe GenerateJufoDescription -pdb_list examples/".$pdblist[$j].".ls -path examples/ -oligo_dict oligomeric_state_dictionary.txt -membrane_orientation_path examples/ -output_prefix examples/".$pdblist[$j]."_".($i+1).".tmp -creating_input_for_first_layer -window_radius 15 -creating_unbalanced_input -creating_nonrandom_input -membrane 11.25 12.5 0 -creating_input_for_testing\n\n");
		print "=== input created: examples/".$pdblist[$j]."_".($i+1).".tmp\n";


		#reformat input file for ANNs, remove shared pointer lines, print it to .dat file
		$lc = 0;
		open (TMPDAT, "examples/".$pdblist[$j]."_".($i+1).".tmp") || print "cannot open temporary .tmp file examples/".$pdblist[$j]."_".($i+1).".tmp\n";
		open (OUT1, ">examples/".$pdblist[$j]."_".($i+1).".dat") || print "cannot open .dat file examples/".$pdblist[$j]."_".($i+1).".dat\n";
		while (my $in = <TMPDAT>){
			chomp $in;
			$in =~ s/^\s+//;
			$lc++;
		
			#remove shared pointer lines
			next if ($in eq "bcl::util::ShPtr<bcl::storage::VectorND<2,bcl::math::Vector<double>>>");
			next if ($in eq "12345678");

			#adjust first line
			if ($lc == 1){
				print OUT1 "bcl::storage::Vector<bcl::storage::VectorND<2,bcl::math::Vector<double>>>\n";
			}
			else {
				print OUT1 "$in\n";
			}
		}
		close OUT1;
		close TMPDAT;
		print "=== reformatted file written: examples/".$pdblist[$j]."_".$i.".dat\n";

		#use ANNs from each monitoring set
		foreach $k (0..4){
			next if ($i == $k);

			#test each model on the protein
#			print "bclJeff2011-08-15.exe TestModel -retrieve_dataset \'File(filename=\"".$path."examples/".$pdblist[$j]."_".($i+1).".dat\",number chunks=1,chunks(\"[0]\"))\' -id_model 0 -model_storage File ".$path."train_10k/".$i.$k."/ -vscreen_filename ".$path."examples/".$pdblist[$j]."_test_".$i.$k."\n";
#			system ("bclJeff2011-08-15.exe TestModel -retrieve_dataset \'File(filename=\"".$path."examples/".$pdblist[$j]."_".($i+1).".dat\",number chunks=1,chunks(\"[0]\"))\' -id_model 0 -model_storage File ".$path."train_10k/".$i.$k."/ -vscreen_filename ".$path."examples/".$pdblist[$j]."_test_".$i.$k."\n");
			print "bcl-apps-static_03192012.exe TestModel -retrieve_dataset 'File(filename=\"".$path."examples/".$pdblist[$j]."_".($i+1).".dat\",number chunks=1,chunks=\"[0]\")' -id_model 2 -storage_model 'File(directory=".$path."train_10k_combi32/".$i.$k."/)' -vscreen_filename ".$path."examples/".$pdblist[$j]."_test_".$i.$k."\n";
			system ("bcl-apps-static_03192012.exe TestModel -retrieve_dataset 'File(filename=\"".$path."examples/".$pdblist[$j]."_".($i+1).".dat\",number chunks=1,chunks=\"[0]\")' -id_model 2 -storage_model 'File(directory=".$path."train_10k_combi32/".$i.$k."/)' -vscreen_filename ".$path."examples/".$pdblist[$j]."_test_".$i.$k."\n");
		}
		print "=== run through each model, output: ".$path."examples/".$pdblist[$j]."_test_".$i.$k."\n";

		#combine the predictions from all four models into one prediction, print tmp jufo file
		print "029_avg_ANN_outputs_to_1_prediction_all-in-line.pl ".$i." examples/".$pdblist[$j]." > examples/analysis_".$pdblist[$j].".txt\n\n";
		system ("029_avg_ANN_outputs_to_1_prediction_all-in-line.pl ".$i." examples/".$pdblist[$j]." > examples/analysis_".$pdblist[$j].".txt\n\n");
		print "=== analyzed output: examples/analysis_".$pdblist[$j].".txt\n";
		print "=== independent tmp file written: tmp".$i.".txt\n";

		#read fasta to include sequence into jufo file
		$sequence = "";
		open (FASTA, "examples/".$pdblist[$j].".fasta") || die "cannot open fasta file examples/".$pdblist[$j].".fasta\n";
		while (my $in = <FASTA>){
			chomp $in;
			next if ($in =~ /^\>/);
			$sequence .= $in;
		}
		close FASTA;
		@sequence = split //, $sequence;

		#write new jufo file, formatting is same as old jufo9D
		$lc = -1;
		open (TMP, "tmp".$i.".txt") || die "cannot open temporary jufo output file tmp".$i.".txt\n";
		open (JUFO, ">examples/".$pdblist[$j]."_".$i.".jufo9d") || die "cannot open jufo output file examples/".$pdblist[$j]."jufo9d\n";
		while (my $in = <TMP>){
			chomp $in;
			$in =~ s/^\s+//;
			$lc++;
			@line = split /\s+/, $in;

			#get maximum indices and sum
			$max = 0;
			$sum = 0;
			foreach $k (0..8){
				if ($line[$k] > $max){
					$max = $line[$k];
					$max_index = $k;
				}
				$sum += $line[$k];
			}

			#normalize to probabilities
			foreach $k (0..8){
				$line[$k] /= $sum;
			}

			#get TM type
			$max_index <= 2 ? $tm = "MC" :
			$max_index > 2 && $max_index <= 5 ? $tm = "TR" :
			$max_index > 5 ? $tm = "SO" : print "";

			#get SS type
			$max_index % 3 == 0 ? $ss = "H" :
			$max_index % 3 == 1 ? $ss = "E" :
			$max_index % 3 == 2 ? $ss = "C" : print "";
	
			#print out
			printf JUFO "%4s", ($lc+1);		#resid
			print JUFO " $sequence[$lc]";		#AA		
			print JUFO " $ss";			#SStype
			print JUFO " $tm ";			#TMtype
			foreach $k (2, 5, 8, 1, 4, 7, 0, 3, 6){	#to keep order as before, C, S, H, TM, TR, SOL
				printf JUFO "  %5.3f", $line[$k];
			}
			print JUFO "\n";
		}
		close TMP;
		print "=== jufo file written: examples/".$pdblist[$j]."_".$i.".jufo9d\n";

		#cleanup
		system ("ln -s ".$path."examples/".$pdblist[$j]."_".$i.".jufo9d ".$path."examples/".$pdblist[$j].".jufo9d");
		system ("ln -s ".$path."examples/".$pdblist[$j].".jufo9d ".$path."database_all/".$pdblist[$j].".jufo9d");
		system ("rm examples/".$pdblist[$j]."_*.dat examples/".$pdblist[$j]."_".($i+1).".tmp examples/".$pdblist[$j].".ls examples/".$pdblist[$j]."_test_??.0.dat\n");
	}
#}

