#!/usr/bin/perl

#====>
#$path = "/home/koehlej/projects/jufo/021_5fold_X-validation/";
#$input = "network.test";
$input = $ARGV[0];


#read in the data
#=====================================================
open (IN, $input) || die "cannot open input file $input\n";

$region_count = 0;
$ss_count = 0;
$total_counts = 0;
$linecount = 0;
$flag = 0;
while ($in = <IN>){
	chomp $in;
	@out = @pred = ();
	$linecount++;
	next if $linecount <= 2;

	$in =~ s/^\s+//;
	@in = split /\s+/, $in;

	foreach $j (0..8){
		push @out, $in[$j];
	}
	foreach $j (9..17){
		push @pred, $in[$j];
	}

	$max_out = 0;
	$max_pred = 0;
	foreach $i (0..8){
		if ($out[$i]  > $max_out){
			$max_out = $out[$i];
			$max_out_element  = $i;
		}
		if ($pred[$i] > $max_pred){
			$max_pred = $pred[$i];
			$max_pred_element = $i;
		}
		
	}
	$counts[$max_out_element][$max_pred_element]++;
	$total_counts++;
	$flag = 0;
}
close IN;

#get the counts from the data
#======================================================
$diagonal_counts = 0;
foreach $i (0..8){		#rows
	foreach $j (0..8){		#columns
		#diagonal and off-diagonal counts (off-diagonal here are with diagonal for now)
		$i == $j ? $diagonal_counts += $counts[$i][$j] : print "";
		$i%3 == $j%3 ? $off_diag_counts += $counts[$i][$j] : print "";

		#for the secondary structure (1st out, 2nd pred)
		($i%3 == 0 && $j%3 == 0) ? $h_h += $counts[$i][$j]:
		($i%3 == 0 && $j%3 == 1) ? $h_s += $counts[$i][$j]:
		($i%3 == 0 && $j%3 == 2) ? $h_c += $counts[$i][$j]:

		($i%3 == 1 && $j%3 == 0) ? $s_h += $counts[$i][$j]:
		($i%3 == 1 && $j%3 == 1) ? $s_s += $counts[$i][$j]:
		($i%3 == 1 && $j%3 == 2) ? $s_c += $counts[$i][$j]:

		($i%3 == 2 && $j%3 == 0) ? $c_h += $counts[$i][$j]:
		($i%3 == 2 && $j%3 == 1) ? $c_s += $counts[$i][$j]:
		($i%3 == 2 && $j%3 == 2) ? $c_c += $counts[$i][$j]: print "";
		
		#for the regions (1st out, 2nd pred)
		($i >= 0 && $i <= 2 && $j >= 0 && $j <= 2) ? $MC_MC   += $counts[$i][$j]:
		($i >= 0 && $i <= 2 && $j >= 3 && $j <= 5) ? $MC_TR   += $counts[$i][$j]:
		($i >= 0 && $i <= 2 && $j >= 6 && $j <= 8) ? $MC_SO  += $counts[$i][$j]:

		($i >= 3 && $i <= 5 && $j >= 0 && $j <= 2) ? $TR_MC   += $counts[$i][$j]:
		($i >= 3 && $i <= 5 && $j >= 3 && $j <= 5) ? $TR_TR   += $counts[$i][$j]:
		($i >= 3 && $i <= 5 && $j >= 6 && $j <= 8) ? $TR_SO  += $counts[$i][$j]:

		($i >= 6 && $i <= 8 && $j >= 0 && $j <= 2) ? $SO_MC  += $counts[$i][$j]:
		($i >= 6 && $i <= 8 && $j >= 3 && $j <= 5) ? $SO_TR  += $counts[$i][$j]:
		($i >= 6 && $i <= 8 && $j >= 6 && $j <= 8) ? $SO_SO += $counts[$i][$j]: print "";

		#take the sum of each row and column
		$sum_row[$i] += $counts[$i][$j];
		$sum_col[$j] += $counts[$i][$j];
	}
}

$off_diag_counts -= $diagonal_counts;

#print "@sum_row\n@sum_col\n\n";

#calculate information gain
foreach $i (0..8){
	foreach $j (0..8){
		$prob = $counts[$i][$j]/$total_counts;
#		$sum_row[$i] /= $total_counts;
#		$sum_col[$j] /= $total_counts;
#print "$sum_row[$i]\n$sum_col[$j]\n\n";
#		$prob != 0 ? $info = $prob * log ($prob)/ log (2) : print "";
#		$prob != 0 ? $info += $prob * log($prob/(1/81))/log 2 : print "";
		$prob != 0 ? $info += $prob * log($prob*$total_counts**2/($sum_row[$i]*$sum_col[$j]))/log 2 : print "";
#print "$counts[$i][$j]\t$prob\t$sum_row[$i]\t$sum_col[$j]\t$info\n";
		
	}
}
#print "\n\n\n$info\n\n\n";

#print the data
#=======================================================
print "\tP\tR\tE\tD\tI\tC\tT\tI\tO\tN\n";
print "OUT\n";
#print "\tSO_C\tTR_C\tMC_C\t\tSO_E\tTR_E\tMC_E\t\tSO_H\tTR_H\tMC_H\n";
print "\tMC_H\tMC_E\tMC_C\t\tTR_H\tTR_E\tTR_C\t\tSO_H\tSO_E\tSO_C\n";

foreach $i (0..8){
	$i == 0 ? print "MC_H\t" :
	$i == 1 ? print "MC_E\t" :
	$i == 2 ? print "MC_C\t" :
	$i == 3 ? print "\nTR_H\t" :
	$i == 4 ? print "TR_E\t" :
	$i == 5 ? print "TR_C\t" :
	$i == 6 ? print "\nSO_H\t" :
	$i == 7 ? print "SO_E\t" :
	$i == 8 ? print "SO_C\t": print "";
	foreach $j (0..8){
		$j == 3 || $j == 6 ? print "\t" : print "";
		$counts[$i][$j] == "" ? $counts[$i][$j] = 0 : print "";
		$i == $j ? print "$counts[$i][$j]\t" : print "$counts[$i][$j]\t";
	}
	print "\n";
}

print "============================================================================================";

print "\n\nby secondary structure";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tH\tE\tC\n";
print "H\t$h_h\t$h_s\t$h_c\n";
print "E\t$s_h\t$s_s\t$s_c\n";
print "C\t$c_h\t$c_s\t$c_c\n";
print "--------------------------------------------------------------------------------------------";

$h_h == 0 ? $h_h = 0.0000000001 : print "";
$s_s == 0 ? $s_s = 0.0000000001 : print "";
$c_c == 0 ? $c_c = 0.0000000001 : print "";

print "\n\nnormalized to out";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tH\tE\tC\n";
print "H\t";
printf "%.2f",$h_h/($h_h + $h_s + $h_c)*100;
print "\t";
printf "%.2f", $h_s/($h_h + $h_s + $h_c)*100;
print "\t";
printf "%.2f", $h_c/($h_h + $h_s + $h_c)*100;
print "\nE\t";
printf "%.2f", $s_h/($s_h + $s_s + $s_c)*100;
print "\t";
printf "%.2f", $s_s/($s_h + $s_s + $s_c)*100;
print "\t";
printf "%.2f", $s_c/($s_h + $s_s + $s_c)*100;
print "\nC\t";
printf "%.2f", $c_h/($c_h + $c_s + $c_c)*100;
print "\t";
printf "%.2f", $c_s/($c_h + $c_s + $c_c)*100;
print "\t";
printf "%.2f", $c_c/($c_h + $c_s + $c_c)*100;
print "\n";
print "============================================================================================";

print "\n\nby region";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tMC\tTR\tSO\n";
print "MC\t$MC_MC\t$MC_TR\t$MC_SO\n";
print "TR\t$TR_MC\t$TR_TR\t$TR_SO\n";
print "SO\t$SO_MC\t$SO_TR\t$SO_SO\n";
print "--------------------------------------------------------------------------------------------";

$SO_SO == 0 ? $SO_SO = 0.0000000001 : print "";
$TR_TR == 0 ? $TR_TR = 0.0000000001 : print "";
$MC_MC == 0 ? $MC_MC = 0.0000000001 : print "";

print "\n\nnormalized by out";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tMC\tTR\tSO\n";
print "MC\t";
printf "%.2f", $MC_MC/($MC_MC + $MC_TR + $MC_SO)*100;
print "\t";
printf "%.2f", $MC_TR/($MC_MC + $MC_TR + $MC_SO)*100;
print "\t";
printf "%.2f", $MC_SO/($MC_MC + $MC_TR + $MC_SO)*100;
print "\nTR\t";
printf "%.2f", $TR_MC/($TR_MC + $TR_TR + $TR_SO)*100;
print "\t";
printf "%.2f", $TR_TR/($TR_MC + $TR_TR + $TR_SO)*100;
print "\t";
printf "%.2f", $TR_SO/($TR_MC + $TR_TR + $TR_SO)*100;
print "\nSO\t";
printf "%.2f", $SO_MC/($SO_MC + $SO_TR + $SO_SO)*100;
print "\t";
printf "%.2f", $SO_TR/($SO_MC + $SO_TR + $SO_SO)*100;
print "\t";
printf "%.2f", $SO_SO/($SO_MC + $SO_TR + $SO_SO)*100;
print "\n";

print "============================================================================================";

#1st out, 2nd prediction
$TMH_TMH = $counts[0][0];
$TMS_TMS = $counts[1][1];
foreach $i (0..8){
	foreach $j (0..8){
		($i == 0 && $j > 0) ? $TMH_noTMH += $counts[$i][$j] : print"";
		if ($i > 0 && $j == 0){
			$noTMH_TMH += $counts[$i][$j];
		}
		($i > 0 && $j > 0) ? $noTMH_noTMH += $counts[$i][$j] : print"";

		($i == 1 && $j != 1) ? $TMS_noTMS += $counts[$i][$j] : print"";
		($i != 1 && $j == 1) ? $noTMS_TMS += $counts[$i][$j] : print"";
		($i != 1 && $j != 1) ? $noTMS_noTMS += $counts[$i][$j] : print"";
	}
}

#print "\n\nby 2-state TM-helix span";
#print "\n\tP R E D I C T I O N\n";
#print "OUT\n";
#print "\tMC_H\telse\n";
#print "MC_H\t$TMH_TMH\t$TMH_noTMH\n";
#print "else\t$noTMH_TMH\t$noTMH_noTMH\n";
#print "--------------------------------------------------------------------------------------------";

print "\n\nnormalized by out";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tMC_H\telse\n";
print "MC_H\t";
printf "%.2f", $TMH_TMH/($TMH_TMH + $TMH_noTMH)*100;
print "\t";
printf "%.2f", $TMH_noTMH/($TMH_TMH + $TMH_noTMH)*100;
print "\nelse\t";
printf "%.2f", $noTMH_TMH/($noTMH_TMH + $noTMH_noTMH)*100;
print "\t";
printf "%.2f", $noTMH_noTMH/($noTMH_TMH + $noTMH_noTMH)*100;
print "\n";

print "============================================================================================";

#print "\n\nby 2-state TM-strand span";
#print "\n\tP R E D I C T I O N\n";
#print "OUT\n";
#print "\tMC_E\telse\n";
#print "MC_E\t$TMS_TMS\t$TMS_noTMS\n";
#print "else\t$noTMS_TMS\t$noTMS_noTMS\n";
#print "--------------------------------------------------------------------------------------------";

print "\n\nnormalized by out";
print "\n\tP R E D I C T I O N\n";
print "OUT\n";
print "\tMC_E\telse\n";
print "MC_E\t";
printf "%.2f", $TMS_TMS/($TMS_TMS + $TMS_noTMS)*100;
print "\t";
printf "%.2f", $TMS_noTMS/($TMS_TMS + $TMS_noTMS)*100;
print "\nelse\t";
printf "%.2f", $noTMS_TMS/($noTMS_TMS + $noTMS_noTMS)*100;
print "\t";
printf "%.2f", $noTMS_noTMS/($noTMS_TMS + $noTMS_noTMS)*100;
print "\n";

print "============================================================================================";

print "\n\ntotal counts:\t\t\t\t$total_counts\n\n";
print ">diagonal\t\t(9-state):\t";
printf "%.4f", $diagonal_counts/$total_counts;
print "\n";
#print "off-diagonal:\t";
#printf "%.4f", $off_diag_counts/$total_counts;
#print "\n";
print ">by secondary structure\t(3-state):\t";
printf "%.4f", ($h_h + $s_s + $c_c)/$total_counts;
print "\n";
print ">by TM region\t\t(3-state):\t";
printf "%.4f", ($SO_SO + $TR_TR + $MC_MC)/$total_counts;
print "\n\n";
print ">by TM helix region\t(2-state):\t";
printf "%.4f", ($TMH_TMH + $noTMH_noTMH)/$total_counts;
print "\n";
print ">by TM strand region\t(2-state):\t";
printf "%.4f", ($TMS_TMS + $noTMS_noTMS)/$total_counts;
print "\n\n";

print ">mutual information (?):\t\t";
printf "%.4f", $info;
print "\n\n";

#printf "%.2f", $TMH_TMH/($TMH_TMH + $TMH_noTMH)*100;
#print "\t";
#printf "%.2f", $noTMH_noTMH/($noTMH_TMH + $noTMH_noTMH)*100;
#print "\t";
#printf "%.4f", ($TMH_TMH + $noTMH_noTMH)/$total_counts;
#print "\n";
#printf "%.2f", $TMS_TMS/($TMS_TMS + $TMS_noTMS)*100;
#print "\t";
#printf "%.2f", $noTMS_noTMS/($noTMS_TMS + $noTMS_noTMS)*100;
#print "\t";
#printf "%.4f", ($TMS_TMS + $noTMS_noTMS)/$total_counts;
#print "\n\n";
