#!/usr/bin/perl

#====>
$independent = $ARGV[0];	#from 0..4
$protein = $ARGV[1];		#only required for name of input file

#$datasets = 5000;
#$datasets = 318391;		#independent 1 unbalanced
#$datasets = 284957;		#independent 2 unbalanced
#$datasets = 286570;		#independent 3 unbalanced
#$datasets = 300654;		#independent 4 unbalanced
#$datasets = 309274;		#independent 5 unbalanced
#$number_networks = 1;
#$total_counts = 9*$datasets*$number_networks;
#$total_counts = $datasets*$number_networks;		#for unbalanced
$algorithm = 1;	#0 = jury with maximal probabilities; 1 = add probabilities - higher;

#read in the data
#=====================================================
$linecount = -1;
foreach $ind ($independent..$independent){

  @prediction = ();

  foreach $mon (0..4){
	next if ($ind == $mon);
	$set = "$ind$mon";
print "$set\n";

	@out = ();
	$linecount = -1;
	$input = "train_10k_combi32/".$set."/testModel".($ind+1)."_unbal_nonrand_gaps2.5_minSSEsize0.2.dat";
#	$input = "train_10k_combi32/".$set."/testModel".($ind+1)."_unbal_nonrand_nogaps.2.dat";
#	$input = "train_10k_combi32/".$set."/testModel".($ind+1)."_MPbeta_unbal_nonrand_nogaps.2.dat";
#	$input = "train_10k/".$set."/testModel".($ind+1)."_sol_unbal_nonrand_nogaps.0.dat";
#	$input = "train_40k/".$set."/descriptors_PDB_9D_40000_w31.ind";
#	$input = "train_20ANNs_dssp_v2_scrambled/".$set."/descriptors_PDB_9D_5000_w31_v2_scrambled.ind";
#	$input = "train_20ANNs_dssp_v3/".$set."/descriptors_PDB_9D_5000_w31_v3.ind";
#	$input = "train_20ANNs_dssp_v4/".$set."/descriptors_PDB_9D_5000_w31_v4.ind";
#	$input = "train_20ANNs_dssp/".$set."/train_PDB_9D_5000_w31_props_dssp.ind1";
#	$input = "train_20ANNs_MPseq/".$set."/testModel_all_unbal_onlyStructures.0.dat";
#	$input = "train_20ANNs_dssp_v4/".$set."/testModel".($ind+1)."_all_unbal_nrand_nogaps.0.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_MPalpha_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_MPbeta_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_MP_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/testModel_sol_unbal_nrand.1.dat";
#	$input = "train_20ANNs_dssp/".$set."/";
#	$input = $protein."_test_".$ind.$mon.".2.dat";
	open (IN, $input) || die "cannot open input file $input\n";
	$flag = 0;
	$cnt = 0;
	while ($in = <IN>){
		chomp $in;
		$in =~ s/^\s+//;

		@pred = ();
		$cnt++;
		next if $cnt <= 2;
		$linecount++;
		@in = split /\s+/, $in;

		#get the true state
		$in1 = "";
		foreach $j (0..8){
			$in1 .= $in[$j]." ";
		}
		push @out, $in1;

		#get the predicted state
		foreach $j (9..17){
			push @pred, $in[$j];
		}

		#get the sum for normalization to get the probabilities
		$sum = 0;
		foreach $i (0..8){
			$pred[$i] += 0.15;
			$sum += $pred[$i];
		}
		#normalize to probabilities
		foreach $i (0..8){
			$pred[$i] /= $sum;
		}
		#make a histogram of the maximal elements, if jury prediction
		if ($algorithm == 0){
			$max_pred = 0;
			foreach $i (0..8){
				if ($pred[$i] > $max_pred){
					$max_pred = $pred[$i];
					$max_pred_element = $i;
				}
			}
			$prediction[$linecount][$max_pred_element]++;		#prediction matrix(lines, prediction probabilities)
		}
		#add the probabilities together, no jury prediction
		if ($algorithm == 1){
			foreach $i (0..8){
				$prediction[$linecount][$i] += $pred[$i];	#prediction matrix(lines, prediction probabilities)
			}
		}
		$flag = 0;
	}
	close IN;
  }
}
$total_counts = $cnt - 2;

#compare the predicted matrix of (lines, output) to the real matrix from the output to get 9x9 matrix
open (OUT, ">tmp".$independent.".txt") || die "cannot open output file tmp".$independent.".txt\n";
foreach $i (0..$linecount){
	@line = split /\s+/, $out[$i];
	$max_out = 0;
	$max_pred = 0;
	foreach $j (0..8){
		$prediction[$i][$j] == "" ? $prediction[$i][$j] = 0 : print "";
		printf OUT "%7.4f", $prediction[$i][$j]."\t";

		#get the maximal element from the output
		if ($line[$j] > $max_out){
			$max_out = $line[$j];
			$max_out_element  = $j;
		}
		#get the maximal element from the prediction
		if ($prediction[$i][$j] > $max_pred){
			$max_pred = $prediction[$i][$j];
			$max_pred_element = $j;
		}
	}
print OUT "\n";
	$counts[$max_out_element][$max_pred_element]++;
}
close OUT;

#get the counts from the data
#======================================================
$diagonal_counts = 0;
foreach $i (0..8){		#rows
	foreach $j (0..8){		#columns
		#diagonal and off-diagonal counts (off-diagonal here are with diagonal for now)
		$i == $j ? $diagonal_counts += $counts[$i][$j] : print "";
		$i%3 == $j%3 ? $off_diag_counts += $counts[$i][$j] : print "";
		
		#for the secondary structure (1st out, 2nd pred)
		($i%3 == 0 && $j%3 == 0) ? $h_h += $counts[$i][$j]:
		($i%3 == 0 && $j%3 == 1) ? $h_e += $counts[$i][$j]:
		($i%3 == 0 && $j%3 == 2) ? $h_c += $counts[$i][$j]:

		($i%3 == 1 && $j%3 == 0) ? $e_h += $counts[$i][$j]:
		($i%3 == 1 && $j%3 == 1) ? $e_e += $counts[$i][$j]:
		($i%3 == 1 && $j%3 == 2) ? $e_c += $counts[$i][$j]:

		($i%3 == 2 && $j%3 == 0) ? $c_h += $counts[$i][$j]:
		($i%3 == 2 && $j%3 == 1) ? $c_e += $counts[$i][$j]:
		($i%3 == 2 && $j%3 == 2) ? $c_c += $counts[$i][$j]: print "";
		
		#for the regions (1st out, 2nd pred)
		($i >= 0 && $i <= 2 && $j >= 0 && $j <= 2) ? $tm_tm   += $counts[$i][$j]:
		($i >= 0 && $i <= 2 && $j >= 3 && $j <= 5) ? $tm_tr   += $counts[$i][$j]:
		($i >= 0 && $i <= 2 && $j >= 6 && $j <= 8) ? $tm_so  += $counts[$i][$j]:

		($i >= 3 && $i <= 5 && $j >= 0 && $j <= 2) ? $tr_tm   += $counts[$i][$j]:
		($i >= 3 && $i <= 5 && $j >= 3 && $j <= 5) ? $tr_tr   += $counts[$i][$j]:
		($i >= 3 && $i <= 5 && $j >= 6 && $j <= 8) ? $tr_so  += $counts[$i][$j]:

		($i >= 6 && $i <= 8 && $j >= 0 && $j <= 2) ? $so_tm  += $counts[$i][$j]:
		($i >= 6 && $i <= 8 && $j >= 3 && $j <= 5) ? $so_tr  += $counts[$i][$j]:
		($i >= 6 && $i <= 8 && $j >= 6 && $j <= 8) ? $so_so += $counts[$i][$j]: print "";

		#take the sum of each row and column
		$sum_row[$i] += $counts[$i][$j];
		$sum_col[$j] += $counts[$i][$j];
	}
}

$off_diag_counts -= $diagonal_counts;
#$total_counts = $diagonal_counts + $off_diag_counts;

#print "@sum_row\n@sum_col\n\n";

foreach $i (0..8){
	foreach $j (0..8){
		$prob = $counts[$i][$j]/$total_counts;
#		$sum_row[$i] /= $total_counts;
#		$sum_col[$j] /= $total_counts;
#print "$sum_row[$i]\n$sum_col[$j]\n\n";
#		$prob != 0 ? $info = $prob * log ($prob)/ log (2) : print "";
#		$prob != 0 ? $info += $prob * log($prob/(1/81))/log 2 : print "";
		$prob != 0 ? $info += $prob * log($prob*$total_counts**2/($sum_row[$i]*$sum_col[$j]))/log 2 : print "";
#print "$counts[$i][$j]\t$prob\t$sum_row[$i]\t$sum_col[$j]\t$info\n";
		
	}
}
#print "\n\n\n$info\n\n\n";

#print the data
#=======================================================
print "\tP\tR\tE\tD\tI\tC\tT\tI\tO\tN\n";
print "OUT\tMC-H\tMC-E\tMC-C\t\tTR-H\tTR-E\tTR-C\t\tSO-H\tSO-E\tSO-C\n";

foreach $i (0..8){
	$i == 0 ? print "MC-H\t" :
	$i == 1 ? print "MC-E\t" :
	$i == 2 ? print "MC-C\t" :
	$i == 3 ? print "\nTR-H\t" :
	$i == 4 ? print "TR-E\t" :
	$i == 5 ? print "TR-C\t" :
	$i == 6 ? print "\nSO-H\t" :
	$i == 7 ? print "SO-E\t" :
	$i == 8 ? print "SO-C\t": print "";
	foreach $j (0..8){
		$j == 3 || $j == 6 ? print "\t" : print "";
		$counts[$i][$j] == "" ? $counts[$i][$j] = "-" : print "";
		$i == $j ? print "$counts[$i][$j]\t" : print "$counts[$i][$j]\t";
	}
	print "\n";
}

print "============================================================================================";

print "\n\nby secondary structure";
print "\n\tP R E D I C T I O N\n";
print "OUT\tH\tE\tC\n";
print "H\t$h_h\t$h_e\t$h_c\n";
print "E\t$e_h\t$e_e\t$e_c\n";
print "C\t$c_h\t$c_e\t$c_c\n";
print "--------------------------------------------------------------------------------------------";

$h_h == 0 ? $h_h = 0.0000000001 : print "";
$e_e == 0 ? $e_e = 0.0000000001 : print "";
$c_c == 0 ? $c_c = 0.0000000001 : print "";

print "\n\nnormalized to out";
print "\n\tP R E D I C T I O N\n";
print "OUT\tH\tE\tC\n";
print "H\t";
printf "%.2f",$h_h/($h_h + $h_e + $h_c)*100;
print "\t";
printf "%.2f", $h_e/($h_h + $h_e + $h_c)*100;
print "\t";
printf "%.2f", $h_c/($h_h + $h_e + $h_c)*100;
print "\nE\t";
printf "%.2f", $e_h/($e_h + $e_e + $e_c)*100;
print "\t";
printf "%.2f", $e_e/($e_h + $e_e + $e_c)*100;
print "\t";
printf "%.2f", $e_c/($e_h + $e_e + $e_c)*100;
print "\nC\t";
printf "%.2f", $c_h/($c_h + $c_e + $c_c)*100;
print "\t";
printf "%.2f", $c_e/($c_h + $c_e + $c_c)*100;
print "\t";
printf "%.2f", $c_c/($c_h + $c_e + $c_c)*100;
print "\n";
print "============================================================================================";

print "\n\nby region";
print "\n\tP R E D I C T I O N\n";
print "OUT\tso\ttr\ttm\n";
print "so\t$so_so\t$so_tr\t$so_tm\n";
print "tr\t$tr_so\t$tr_tr\t$tr_tm\n";
print "tm\t$tm_so\t$tm_tr\t$tm_tm\n";
print "--------------------------------------------------------------------------------------------";

$tm_tm == 0 ? $tm_tm = 0.0000000001 : print "";
$tr_tr == 0 ? $tr_tr = 0.0000000001 : print "";
$so_so == 0 ? $so_so = 0.0000000001 : print "";

print "\n\nnormalized by out";
print "\n\tP R E D I C T I O N\n";
print "OUT\tso\ttr\ttm\n";
print "so\t";
printf "%.2f", $so_so/($so_so + $so_tr + $so_tm)*100;
print "\t";
printf "%.2f", $so_tr/($so_so + $so_tr + $so_tm)*100;
print "\t";
printf "%.2f", $so_tm/($so_so + $so_tr + $so_tm)*100;
print "\ntr\t";
printf "%.2f", $tr_so/($tr_so + $tr_tr + $tr_tm)*100;
print "\t";
printf "%.2f", $tr_tr/($tr_so + $tr_tr + $tr_tm)*100;
print "\t";
printf "%.2f", $tr_tm/($tr_so + $tr_tr + $tr_tm)*100;
print "\ntm\t";
printf "%.2f", $tm_so/($tm_so + $tm_tr + $tm_tm)*100;
print "\t";
printf "%.2f", $tm_tr/($tm_so + $tm_tr + $tm_tm)*100;
print "\t";
printf "%.2f", $tm_tm/($tm_so + $tm_tr + $tm_tm)*100;
print "\n";

print "============================================================================================";
print "\n\ndiagonal counts:\t\t\t$diagonal_counts\n";
print "total counts:\t\t\t\t$total_counts\n\n";
print "diagonal\t\t(9-state):\t";
printf "%.4f", $diagonal_counts/$total_counts;
print "\n";
print "by secondary structure\t(3-state):\t";
printf "%.4f", ($h_h + $e_e + $c_c)/$total_counts;
print "\n";
print "by TM region\t\t(3-state):\t";
printf "%.4f", ($tm_tm + $tr_tr + $so_so)/$total_counts;
print "\n\n";
print "mutual information (?):\t\t\t";
printf "%.4f", $info;
print "\n";

