#!/usr/bin/perl 

#@proteins = qw(1jb0A 1jb0B 1jb0C 1jb0D 1jb0E 1jb0F 1jb0I 1jb0J 1jb0K 1jb0L 1jb0X);
#@proteins = qw(1kf6A 1kf6B 1kf6C 1kf6D 1kf6M 1kf6N 1kf6O 1kf6P);
#@proteins = qw(1kqfA 1kqfB 1kqfC 1kqfD 1kqfE 1kqfF 1kqfG 1kqfH 1kqfI);
#@proteins = qw(1rzhH 1rzhL 1rzhM);
#@proteins = qw(1uunA 1uunB 1uunC 1uunD 1uunE 1uunF 1uunG 1uunH);
#@proteins = qw(1yc9A 1yc9B 1yc9C);
#@proteins = qw(2bs2A 2bs2B 2bs2C 2bs2D 2bs2E 2bs2F);
#@proteins = qw(2gr8A 2gr8C 2gr8D);
#@proteins = qw(2yl4A 2yl4B);
#@proteins = qw(2zxeA 2zxeB 2zxeG);
#@proteins = qw(3a2sA 3a2sB 3a2sX); 
#@proteins = qw(3dzmA);
#@proteins = qw(3q7kA 3q7kB 3q7kC 3q7kD 3q7kE);
#@proteins = qw(3rfzA 3rfzB 3rfzC);
#@proteins = qw(1qj8A);
#@proteins = qw(3o44A);
#@proteins = qw(1fepA);
#@proteins = qw(2j8sA 2j8sB 2j8sC 2j8sD 2j8sE);
#@proteins = qw(2K73A);
@proteins = qw(4A82A 4A82B);

#@proteins = qw();	#series of 5lc but only same protein

#$out = "/home/koehlej/projects/jufo/039_training_9D/jufo_pymol/021_figures_SSPred_10k_combi32.py";
#$pdb = "/home/koehlej/projects/jufo/039_training_9D/database_all/".substr($proteins[0], 0, 4)."biobcl.pdb";
$pdb = "/home/koehlej/projects/jufo/039_training_9D/BCLjufo_app/".substr($proteins[0], 0, 4)."biobcl.pdb";
$out = "/home/koehlej/projects/jufo/039_training_9D/example_figures/".substr($proteins[0], 0, 4)."_ss.py";

open (OUT, ">".$out) || die "cannot open pymol output file\n";
print OUT "bg_color white\n";
print OUT "set orthoscopic=0\n";
print OUT "set depth_cue=1\n";
print OUT "set ray_shadows=0\n";
print OUT "set direct, 0.5\n\n";

print OUT "load $pdb, ".substr($proteins[0], 0, 4)."\n";
print OUT "hide all\n";
print OUT "color green, $protein\n";
print OUT "set_view (\\
     0.999444425,    0.006301597,    0.032717615,\\
     0.032508094,    0.030959809,   -0.998990893,\\
    -0.007308172,    0.999501169,    0.030737476,\\
    -0.000000129,    0.000014961, -331.943878174,\\
    -0.943946183,   -0.041751988,   33.270534515,\\
   258.050537109,  405.837219238,    0.000000000 )\n";

foreach $protein (@proteins){

	@pred = @seqid = @chain = @s_s = @s_cs = @s_e = @s_ce = @h_s = @h_cs = @h_e = @h_ce = ();

#$protein = "3EML";
#$protein = "2GIF";
#$pdb = "/home/koehlej/projects/jufo/015_benchmark_dataset/d003_test_benchmark_large_2nd_layer_ANN/d001_dataset_files/".$protein."bcl.pdb";
#	$jufo = "/home/koehlej/projects/jufo/039_training_9D/examples/".$protein.".jufo9d";
	$jufo = "/home/koehlej/projects/jufo/039_training_9D/BCLjufo_app/".$protein.".jufo9d";
#	$jufo = "/home/koehlej/projects/jufo/039_training_9D/jufo_single_chains_10k_combi32/".$protein.".jufo9d";

	$cnt = 0;
	open (JUFO, $jufo) || print "cannot open Jufo file $jufo\n";
	while ($in = <JUFO>){
		chomp $in;
		$in =~ s/^\s+//;
		@in = split /\s+/, $in;
		push @pred, $in[2];
		push @seqid, $in[0];
		push @chain, substr($protein, 4, 1);
	}
	
	foreach $i (0..$#seqid){
#beginning
#		$i == 0 && $pred[0] =~ /C/ ? push @c_s, $seqid[0] : print ""; 
#		$i == 0 && $pred[0] =~ /C/ ? push @c_cs, $chain[0] : print ""; 

		$i == 0 && $pred[0] =~ /E/ ? push @s_s, $seqid[0] : print ""; 
		$i == 0 && $pred[0] =~ /E/ ? push @s_cs, $chain[0] : print ""; 

		$i == 0 && $pred[0] =~ /H/ ? push @h_s, $seqid[0] : print ""; 
		$i == 0 && $pred[0] =~ /H/ ? push @h_cs, $chain[0] : print ""; 

		$pushed_strand = 0;
		$pushed_helix = 0;

#middle of the sequence, start
		if ($pred[$i] !~ /E/ && $pred[$i+1] =~ /E/){
			push @s_s, $seqid[$i+1]; 
			push @s_cs, $chain[$i+1];
		}
		if ($pred[$i] !~ /H/ && $pred[$i+1] =~ /H/){
			push @h_s, $seqid[$i+1]; 
			push @h_cs, $chain[$i+1];
		}
#middle of the sequence, end
		if ($pred[$i] =~ /E/ && $pred[$i+1] !~ /E/){
			push @s_e, $seqid[$i]; 
			push @s_ce, $chain[$i];
			$pushed_strand = 1;
		}
		if ($pred[$i] =~ /H/ && $pred[$i+1] !~ /H/){
			push @h_e, $seqid[$i]; 
			push @h_ce, $chain[$i];
			$pushed_helix = 1;
		}
#chainbreaks
		if ($chain[$i] ne $chain[$i+1]){
#end
			if ($pred[$i] =~ /E/ && $pushed_strand == 0){
				push @s_e, $seqid[$i]; 
				push @s_ce, $chain[$i];
			}
			if ($pred[$i] =~ /H/ && $pushed_helix == 0){
				push @h_e, $seqid[$i]; 
				push @h_ce, $chain[$i];
			}
#start
			if ($pred[$i+1] =~ /E/ && $pushed_strand == 0){
				push @s_s, $seqid[$i+1]; 
				push @s_cs, $chain[$i+1];
			}
			if ($pred[$i+1] =~ /H/ && $pushed_helix == 0){
				push @h_s, $seqid[$i+1]; 
				push @h_cs, $chain[$i+1];
			}
		}
#if pushed twice
		if ($s_e[-1] == $s_e[-2]){
			pop @s_e;
			pop @s_ce;
		}
		if ($h_e[-1] == $h_e[-2]){
			pop @h_e;
			pop @h_ce;
		}
		if ($s_s[-1] == $s_s[-2]){
			pop @s_s;
			pop @s_cs;
		}
		if ($h_s[-1] == $h_s[-2]){
			pop @h_s;
			pop @h_cs;
		}

#	$#s_e == $#s_s+1 ? pop @s_e : print "";
#	$#h_e == $#h_s+1 ? pop @h_e : print "";
#	$#s_ce == $#s_cs+1 ? pop @s_ce : print "";
#	$#h_ce == $#h_cs+1 ? pop @h_ce : print "";
	}


	@s_cs ne @s_ce ? print "ERROR: strand start and end chains do not agree for $protein\n" : print "";
	@h_cs ne @h_ce ? print "ERROR: helix start and end chains do not agree for $protein\n" : print "";

#print "$#s_s\t$#s_e\n@s_s\n\n@s_e\n\n\n\n";
#print "$#s_cs\t$#s_ce\n@s_cs\n\n@s_ce\n\n\n\n";
#print "$#h_s\t$#h_e\n@h_s\n\n@h_e\n";
#print "$#h_cs\t$#h_ce\n@h_cs\n\n@h_ce\n";

#print "$tm_s[$#tm_s+1]\n";

	close JUFO;

	foreach $s (0..$#s_s){
		print OUT "select strand, ";
		print OUT "(".substr($proteins[0], 0, 4)." and c;$s_cs[$s] and i;$s_s[$s]-$s_e[$s])\n";
		print OUT "color blue, strand\n\n";
	}

	foreach $h (0..$#h_s){
		print OUT "select helix, ";
		print OUT "(".substr($proteins[0], 0, 4)." and c;$h_cs[$h] and i;$h_s[$h]-$h_e[$h])\n";
		print OUT "color red, helix\n\n";
	}

}
	print OUT "show cartoon, all\n";
#	print OUT "center\nzoom\norient\n";
#	print OUT "ray\n";
#	print OUT "png ".$protein."_SSPred_$i.png\n";
#	print OUT "disable $protein\n\n\n";


