#!/usr/bin/perl 

#@proteins = qw(1jb0A 1jb0B 1jb0C 1jb0D 1jb0E 1jb0F 1jb0I 1jb0J 1jb0K 1jb0L 1jb0X);
#@proteins = qw(1kf6A 1kf6B 1kf6C 1kf6D 1kf6M 1kf6N 1kf6O 1kf6P);
#@proteins = qw(1kqfA 1kqfB 1kqfC 1kqfD 1kqfE 1kqfF 1kqfG 1kqfH 1kqfI);
#@proteins = qw(1rzhH 1rzhL 1rzhM);
#@proteins = qw(1uunA 1uunB 1uunC 1uunD 1uunE 1uunF 1uunG 1uunH);
#@proteins = qw(1yc9A 1yc9B 1yc9C);
#@proteins = qw(2bs2A 2bs2B 2bs2C 2bs2D 2bs2E 2bs2F);
#@proteins = qw(2gr8A 2gr8C 2gr8D);
#@proteins = qw(2yl4A 2yl4B);
#@proteins = qw(2zxeA 2zxeB 2zxeG);
#@proteins = qw(3a2sA 3a2sB 3a2sX); 
#@proteins = qw(3dzmA);
#@proteins = qw(3q7kA 3q7kB 3q7kC 3q7kD 3q7kE);
#@proteins = qw(3rfzA 3rfzB 3rfzC);
#@proteins = qw(1qj8A);
#@proteins = qw(3o44A);
#@proteins = qw(1fepA);
#@proteins = qw(2j8sA 2j8sB 2j8sC 2j8sD 2j8sE);
#@proteins = qw(2K73A);
@proteins = qw(4A82A 4A82B);

#@proteins = qw();	#series of 5lc but only same protein

#$out = "/home/koehlej/projects/jufo/039_training_9D/jufo_pymol/021_figures_SSPred_10k_combi32.py";
#$pdb = "/home/koehlej/projects/jufo/039_training_9D/database_all/".substr($proteins[0], 0, 4)."biobcl.pdb";
$pdb = "/home/koehlej/projects/jufo/039_training_9D/BCLjufo_app/".substr($proteins[0], 0, 4)."biobcl.pdb";
$out = "/home/koehlej/projects/jufo/039_training_9D/example_figures/".substr($proteins[0], 0, 4)."_tm.py";

open (OUT, ">".$out) || die "cannot open pymol output file $out\n";
print OUT "bg_color white\n";
print OUT "set orthoscopic=0\n";
print OUT "set depth_cue=1\n";
print OUT "set ray_shadows=0\n";
print OUT "set direct, 0.5\n\n";

print OUT "load $pdb, ".substr($proteins[0], 0, 4)."\n";
print OUT "hide all\n";
print OUT "color blue, $protein\n";
print OUT "set_view (\\
     0.999444425,    0.006301597,    0.032717615,\\
     0.032508094,    0.030959809,   -0.998990893,\\
    -0.007308172,    0.999501169,    0.030737476,\\
    -0.000000129,    0.000014961, -331.943878174,\\
    -0.943946183,   -0.041751988,   33.270534515,\\
   258.050537109,  405.837219238,    0.000000000 )\n";

foreach $protein (@proteins){

	@pred = @seqid = @chain = @tm_s = @tm_cs = @tm_e = @tm_ce = @tr_s = @tr_cs = @tr_e = @tr_ce = ();

#$protein = "1BE3";
#$protein = "2GIF";
#$pdb = "/home/koehlej/projects/jufo/015_benchmark_dataset/d003_test_benchmark_large_2nd_layer_ANN/d001_dataset_files/".$protein."bcl.pdb";
	$jufo = "/home/koehlej/projects/jufo/039_training_9D/BCLjufo_app/".$protein.".jufo9d";
#	$jufo = "/home/koehlej/projects/jufo/039_training_9D/examples/".$protein.".jufo9d";
#	$jufo = "/home/koehlej/projects/jufo/039_training_9D/jufo_single_chains_10k_combi32/".$protein.".jufo9d";

	$cnt = 0;
	open (JUFO, $jufo) || die "cannot open Jufo file \n";
	while ($in = <JUFO>){
		chomp $in;
		$in =~ s/^\s+//;
		@in = split /\s+/, $in;
		push @pred, $in[3];
		push @seqid, $in[0];
		push @chain, substr($protein, 4, 1);
	}
	
	foreach $i (0..$#seqid){
#beginning
		$i == 0 && ($pred[0] eq "TR") ? push @tr_s, $seqid[0] : print ""; 
		$i == 0 && ($pred[0] eq "TR") ? push @tr_cs, $chain[0] : print ""; 

		$i == 0 && ($pred[0] eq "MC") ? push @tm_s, $seqid[0] : print ""; 
		$i == 0 && ($pred[0] eq "MC") ? push @tm_cs, $chain[0] : print ""; 

#middle of the sequence, start
		if ($pred[$i] ne "MC" && $pred[$i+1] eq "MC"){
			push @tm_s, $seqid[$i+1]; 
			push @tm_cs, $chain[$i+1];
		}
		if (($pred[$i] ne "TR") && ($pred[$i+1] eq "TR")){
			push @tr_s, $seqid[$i+1]; 
			push @tr_cs, $chain[$i+1];
		}
#middle of the sequence, end
		if ($pred[$i] eq "MC" && $pred[$i+1] ne "MC"){
			push @tm_e, $seqid[$i]; 
			push @tm_ce, $chain[$i];
		}
		if (($pred[$i] eq "TR") && ($pred[$i+1] ne "TR")){
			push @tr_e, $seqid[$i]; 
			push @tr_ce, $chain[$i];
		}
#chainbreaks
		if ($chain[$i] ne $chain[$i+1]){
			if ($pred[$i] eq "MC"){
				push @tm_e, $seqid[$i]; 
				push @tm_ce, $chain[$i];
			}
			if ($pred[$i] eq "TR"){
				push @tr_e, $seqid[$i]; 
				push @tr_ce, $chain[$i];
			}

			if ($pred[$i+1] eq "MC"){
				push @tm_s, $seqid[$i+1]; 
				push @tm_cs, $chain[$i+1];
			}
			if ($pred[$i+1] eq "TR"){
				push @tr_s, $seqid[$i+1]; 
				push @tr_cs, $chain[$i+1];
			}
		}
#if pushed twice
		if ($tm_e[-1] == $tm_e[-2]){
			pop @tm_e;
			pop @tm_ce;
		}
		if ($tr_e[-1] == $tr_e[-2]){
			pop @tr_e;
			pop @tr_ce;
		}
		if ($tm_s[-1] == $tm_s[-2]){
			pop @tm_s;
			pop @tm_cs;
		}
		if ($tr_s[-1] == $tr_s[-2]){
			pop @tr_s;
			pop @tr_cs;
		}
	}

#	$#tm_e == $#tm_s+1 ? pop @tm_e : print "";
#	$#tr_e == $#tr_s+1 ? pop @tr_e : print "";
#	$#tm_ce == $#tm_cs+1 ? pop @tm_ce : print "";
#	$#tr_ce == $#tr_cs+1 ? pop @tr_ce : print "";

	@tm_cs ne @tm_ce ? print "ERROR: TM start and end chains do not agree for $protein\n" : print "";
	@tr_cs ne @tr_ce ? print "ERROR: TR start and end chains do not agree for $protein\n" : print "";

#print "$#tm_s\t$#tm_e\n@tm_s\n\n@tm_e\n\n\n\n";
#print "$#tm_cs\t$#tm_ce\n@tm_cs\n\n@tm_ce\n\n\n\n";
#print "$#tr_s\t$#tr_e\n@tr_s\n\n@tr_e\n";
#print "$#tr_cs\t$#tr_ce\n@tr_cs\n\n@tr_ce\n";

#print "$tm_s[$#tm_s+1]\n";

	close JUFO;

	foreach $tm (0..$#tm_s){
		print OUT "select tm, ";
		print OUT "(".substr($proteins[0], 0, 4)." and c;$tm_cs[$tm] and i;$tm_s[$tm]-$tm_e[$tm])\n";
		print OUT "color red, tm\n\n";
	}

	foreach $tr (0..$#tr_s){
		print OUT "select tr, ";
		print OUT "(".substr($proteins[0], 0, 4)." and c;$tr_cs[$tr] and i;$tr_s[$tr]-$tr_e[$tr])\n";
		print OUT "color white, tr\n\n";
	}

}
	print OUT "show cartoon, all\n";
#	print OUT "center\nzoom\norient\n";
#	print OUT "ray\n";
#	print OUT "png ".$protein."_TMPred_$i.png\n\n\n";
#	print OUT "disable $protein\n\n\n";

