#!/usr/bin/perl

$input = "train_10k_combi32/outputs".$ARGV[0]."_avgANNs.txt";

$lc = 0;
open (IN, $input) || die "cannot open input file $input\n";
while ($in = <IN>){
	chomp $in;
	$lc++;
	$log = 0;
	$log_sspred = 0;
	$log_tmpred = 0;

	@in = split /\s+/, $in;

	#infogain for 9D
	foreach $i (0..8){
		$log += $in[$i]*(log (9*$in[$i]))/log 2;
	}
	$info += $log;

	#SSPred
	$h = $in[0] + $in[3] + $in[6];
	$s = $in[1] + $in[4] + $in[7];
	$c = $in[2] + $in[5] + $in[8];

	#TMPred
	$tm = $in[0] + $in[1] + $in[2];
	$tr = $in[3] + $in[4] + $in[5];
	$so = $in[6] + $in[7] + $in[8];

	#infogain 3D
	$log_sspred = (($h*log (3*$h)) + ($s*log (3*$s)) + ($c*log(3*$c))) / log 2;
	$info_sspred += $log_sspred;
#print "$log_sspred\t$info_sspred\n";
	$log_tmpred = (($tm*log (3*$tm)) + ($tr*log (3*$tr)) + ($so*log(3*$so))) / log 2;
	$info_tmpred += $log_tmpred;
}
close IN;

$info = sprintf "%.3f", $info/$lc;
$info_sum3d = $info_sspred + $info_tmpred;
$info_sspred = sprintf "%.3f", $info_sspred/$lc;
$info_tmpred = sprintf "%.3f", $info_tmpred/$lc;
$info_sum3d  = sprintf "%.3f", $info_sum3d/$lc;
print "info:\t$info\t$info_sspred\t$info_tmpred\t$info_sum3d\n";
