#!/usr/bin/perl

$dataset = $ARGV[0];	#0..4
$set = "$ARGV[1]";	#to take for template files, 01 for instance

$infile = "/home/koehlej/projects/jufo/039_training_9D/train_10k_combi32/outputs".$dataset."_avgANNs.txt";
$out_template = "/home/koehlej/projects/jufo/039_training_9D/train_10k_combi32/".$set."/testModel".($dataset+1)."_unbal_nonrand_nogaps.2.dat"; #template contains the actual output as the first 9 columns, the rest are the predictions
#$infile = "/home/koehlej/projects/jufo/039_training_9D/train_10k_combi32/fun1";
#$out_template = "/home/koehlej/projects/jufo/039_training_9D/train_10k_combi32/fun2";
$out_file = "topology_testModel_ds".($dataset+1).".dat";

#read input file (averages over 5 ANNs)
open (IN, $infile) || die "cannot open input file $file\n";
while ($in = <IN>){
	chomp $in;
	$in =~ s/^\s+//;
	@in = split /\s+/, $in;

	#do 2-state baseline correction for TMhelix
	$TMH = $in[0] + ((7*0.111)/2);
	$noTMH = 0;
	foreach $i (1..8){
		$noTMH += $in[$i];
	}
	$noTMH -= (7*0.111)/2;

	#do 2-state baseline correction for TMstrand
	$TMS = $in[1] + ((7*0.111)/2);
	$noTMS = 0;
	foreach $i (0,2..8){
		$noTMS += $in[$i];
	}
	$noTMS -= (7*0.111)/2;

	#convert probabilities into topology
	$TMH >= $noTMH ? $TMHtopo = "H" : 
	$TMH <  $noTMH ? $TMHtopo = "-" : print "";

	$TMS >= $noTMS ? $TMStopo = "S" : 
	$TMS <  $noTMS ? $TMStopo = "-" : print "";

	#make the 2-state prediction exclusive: if it is helix, it can't be strand
	$TMHtopo eq "H" && $TMStopo eq "S" && $TMH > $TMS ? $TMStopo = "-" : 
	$TMHtopo eq "H" && $TMStopo eq "S" && $TMH < $TMS ? $TMHtopo = "-" : print "";

	#write topology array
	$TMHtopo eq "H" 		     ? push @topo, "H" : 
	$TMStopo eq "S" 		     ? push @topo, "S" :
	($TMHtopo eq "-" && $TMStopo eq "-") ? push @topo, "-" : print "";
}
close IN;

#remove kinks in copied array to be able to get length of SSE without kink
@topo_nokinks = @topo;
foreach $i (1..$#topo_nokinks+1){
	if ($topo[$i-1] eq "H" && $topo[$i] ne "H" && $topo[$i+1] eq "H"){
		$topo_nokinks[$i] = "H";
	}
	if ($topo[$i-1] eq "S" && $topo[$i] ne "S" && $topo[$i+1] eq "S"){
		$topo_nokinks[$i] = "S";
	}

#	$i%50==1 ? print "\n" : print "";
#	$i%10==1 ? print " " : print "";
#	print "$topo_nokinks[$i-1]";
}
#print "\n\n";

#get length of TMspan as if no kinks were present (kink is 1 residue long)
$length = 0;
foreach $i (0..$#topo_nokinks){
	#only for beginning of the array
	if ($i == 0 && $topo_nokinks[$i] =~ /[A-Z]/){
		foreach $j ($i..$i+1000){
			$topo_nokinks[$j] =~ /[A-Z]/ ? $length++ : last;
		}
	}
	#get length starting at first residue of SSE
	elsif ($topo_nokinks[$i] =~ /[A-Z]/ && $topo_nokinks[$i-1] eq "-"){
		foreach $j ($i..$i+1000){
			$topo_nokinks[$j] =~ /[A-Z]/ ? $length++ : last;
		}
	}
	elsif ($topo_nokinks[$i] eq "-"){
		$length = 0;
	}

	push @length, $length;
}

#remove short TMspans
foreach $i (0..$#topo){
	#initialize TM improved topology array
	$new_topo[$i] = $topo[$i];

	#compare to array without kinks, remove strands shorter than 5 residues (optimized)
	if ($topo_nokinks[$i] eq "S" && $length[$i] < 5){
		$new_topo[$i] = "-";
		$topo_nokinks[$i] = "-";
	}
	#compare to array without kinks, remove helices shorter than 11 residues (optimized)
	elsif ($topo_nokinks[$i] eq "H" && $length[$i] < 11){
		$new_topo[$i] = "-";
		$topo_nokinks[$i] = "-";
	}
#print "$length ";
#print "$topo[$i]\t$topo_nokinks[$i]\t$new_topo[$i]\t$length[$i]\n";

#	$i%50==0 ? print "\n" : print "";
#	$i%10==0 ? print " " : print "";
#	print "$new_topo[$i]";
#	print "$topo_nokinks[$i]";
}
#print "\n";

#read template file (has actual output in first 9 columns, write out similar file with topology converted into 9-state predictions)
open (TEMPLATE, $out_template) || die "cannot open input file $out_template\n";
open (OUT, ">".$out_file) || die "cannot open output file $out_file\n";
$lc = 0;
while ($in = <TEMPLATE>){
	chomp $in;
	$in =~ s/^\s+//;
	$lc++;

	#print header, need to be able to use 027 script
	if ($lc <= 2){
		print OUT "$in\n";
	}
	else {
		@in = split /\s+/, $in;

		#print actual output
		foreach $i (0..8){
			print OUT "$in[$i]\t";		
		}
#print  "\t";	
		#convert topology back into 9-state prediction using 0's and 1's
		if ($new_topo[$lc-3] eq "H"){
			$new_topo_pred =           "1\t".("0\t"x8);
		}
		elsif ($new_topo[$lc-3] eq "S"){
			$new_topo_pred = ("0\t"x1)."1\t".("0\t"x7);
		}
		else {
			$new_topo_pred = ("0\t"x8)."1";
		}

		#print predicted topology, kinks are not removed
		print OUT "$new_topo_pred\n";
	}
}
close OUT;
close TEMPLATE;


