#!/usr/bin/perl 

$dataset = $ARGV[0];	#starts from 1

$in_file = "/home/koehlej/projects/jufo/039_training_9D/descriptors/descriptors".$dataset."_unbal_nonrand_nogaps.dat";
$pred_file = "/home/koehlej/projects/jufo/039_training_9D/psipred_ds".$dataset.".psipred_ss2";
#$pred_file = "/home/koehlej/projects/jufo/039_training_9D/train_10k_combi32/outputs0_avgANNs.txt";
#$in_file = "/home/koehlej/projects/jufo/039_training_9D/fun";
#$pred_file = "/home/koehlej/projects/jufo/039_training_9D/fun1";

#read the descriptor input file
#save the TM and SS state
$lc = 0;
open (IN, $in_file) || die "cannot open input file $in_file\n";
while ($in = <IN>){
	chomp $in;
	$lc++;
#	$lc % 100 == 0 ? print "$lc\n" : print "";
	$in =~ s/^\s+//;

	#only looks at lines that define output state
	next unless ($lc > 2 && $lc%7==2);
	@in = split /\s+/, $in;

	#turn output 9D state into SState
	foreach $i (0..8){
		$in[$i] == 1 && $i%3==0 ? $SSstate = "H" :
		$in[$i] == 1 && $i%3==1 ? $SSstate = "S" :
		$in[$i] == 1 && $i%3==2 ? $SSstate = "C" : print "";

		$in[$i] == 1 && $i<3 ? $TMstate = "TM" : 
		$in[$i] == 1 && $i>=3 && $i<=5 ? $TMstate = "T" :
		$in[$i] == 1 && $i>5 ? $TMstate = "S" : print "";
	}

	#write into array
	push @SSstate, $SSstate;
	push @TMstate, $TMstate;
}
close IN;

#print "read descriptor file\n";

#read the PsiPred prediction file
open (PRED, $pred_file) || die "cannot open input file $pred_file\n";
while ($in = <PRED>){
	chomp $in;
	$in =~ s/^\s+//;
	@in = split /\s+/, $in;

	$SSPred = $in[2];

	#write into array
	push @SSPred, $SSPred;
}
close PRED;

#print "read predictions file\n";

#read both arrays: SSstate, SSPred
$length = 0;
foreach $i (0..$#SSstate){
#print "$i\t$SSPred[$i]\n";
	#get TM span length
	if ($TMstate[$i] eq "TM" && $TMstate[$i-1] ne "TM"){
		foreach $j ($i..$i+50){
			$TMstate[$j] eq "TM" ? $length++ : last;
		}
	}
	elsif ($TMstate[$i] ne "TM"){
		$length = 0;
	}
	
	#check for kink
	if ($length > 11 && $TMstate[$i] eq "TM" && $TMstate[$i-1] ne "TM"){
#print "$TMstate[$i]\t$SSstate[$i]\t$TMPred[$i]\t$SSPred[$i]\t$length\t\t";

		foreach $j ($i..$i+$length-1){
			#identify kinks
			$kink_id = 0;

			#1-residue kink
			if ($SSstate[$j-1] eq "H" && $SSstate[$j] eq "C" && $SSstate[$j+1] eq "H" && $j >= $i + 1 && $j <= $i+$length-2){
				$kink_id = $j;
				print "kink1\t$kink_id\n";
			}
			#2-residue kink
			elsif ($SSstate[$j-1] eq "H" && $SSstate[$j] eq "C" && $SSstate[$j+1] eq "C" && $SSstate[$j+2] eq "H" && $j >= $i + 1 && $j <= $i+$length-3){
				$kink_id = $j;
				print "kink2\t$kink_id\n";
			}
			
next if $kink_id == 0;

			#see if kink is predicted in +/- 5 residues
			foreach $k ($kink_id-10..$kink_id+10){
#print "$kink_id\t$k\n";
#print "$kink_id\t$k\t$TMstate[$k]\t$SSstate[$k]\t$TMPred[$k]\t$SSPred[$k]\t$length\n";
				if ($SSPred[$k-1] eq "H" && $SSPred[$k] eq "C" && $SSPred[$k+1] eq "H" && $k >= $kink_id-4 && $k <= $kink_id+4){
					print "kink1 predicted:\n";
				}

				elsif ($SSPred[$k-1] eq "H" && $SSPred[$k] eq "C" && $SSPred[$k+1] eq "C" && $SSPred[$k+2] eq "H" && $k >= $kink_id-4 && $k <= $kink_id+3){
					print "kink2 predicted:\n";
				}
			}
			print "\n";
 		}
	}
}

