#!/usr/bin/perl 

$dataset = $ARGV[0];	#starts at 1

#$in_file = "/home/koehlej/projects/jufo/039_training_9D/descriptors/descriptors".$dataset."_unbal_nonrand_nogaps.dat";
#$pred_file = "/home/koehlej/projects/jufo/039_training_9D/train_10k_combi32/outputs".($dataset-1)."_avgANNs.txt";
$in_file = "/home/koehlej/projects/jufo/039_training_9D/test41-desc.in";
$pred_file = "/home/koehlej/projects/jufo/039_training_9D/test40-pred.in";

#read the descriptor input file
#save the SS and SS state
$lc = 0;
open (IN, $in_file) || die "cannot open input file $in_file\n";
while ($in = <IN>){
	chomp $in;
	$lc++;
	$in =~ s/^\s+//;

	#only looks at lines that define output state
	next unless ($lc > 2 && $lc%7==2);
	@in = split /\s+/, $in;

	#turn output 9D state into SState
	foreach $i (0..8){
		$in[$i] == 1 && $i%3==0 ? $SSstate = "H" :
		$in[$i] == 1 && $i%3==1 ? $SSstate = "S" :
		$in[$i] == 1 && $i%3==2 ? $SSstate = "C" : print "";
	}

	#write into array
	push @SSstate, $SSstate;
}
close IN;

#read the ANN output file where averaged over 5 ANNs
open (PRED, $pred_file) || die "cannot open input file $pred_file\n";
while ($in = <PRED>){
	chomp $in;
	$in =~ s/^\s+//;
	@in = split /\s+/, $in;

	#get the maximum of the probabilities
	$max = 0;
	foreach $i (0..8){
		if ($in[$i] >= $max){
			$max = $in[$i];
			$max_element = $i;
		}
	}

	#turn most probable state into SS and SSstate
	$max_element%3==0 ? $SSPred = "H" :
	$max_element%3==1 ? $SSPred = "S" :
	$max_element%3==2 ? $SSPred = "C" : print "";

	#write into array
	push @SSPred, $SSPred;
}
close PRED;

#initialize matrices with zero counts, 81 because longest SSE is 81 residues long
foreach $length (1..81){
	foreach $iter (0..$length){
		$correct_SSPred[$length][$iter] = 0;
	}
}

#read both arrays: SSstate, SSPred
foreach $i (0..$#SSstate){
	#get end of SS span before
	$end_before = $start_end[-1];
	$end_before =~ s/e//;

	#write array with start and end of SS spans
	if ($SSstate[$i-1] ne $SSstate[$i] && $SSstate[$i] ne "C"){
		$flag = 0; #all coil
		foreach $k ($i..$i+100){
			if ($SSstate[$k] eq "C" && $SSstate[$k-1] ne "C"){
				$length = $k - $i;
				last;
			}
		}
		if ($length > 1 && $i > 5 && $start_end[0] eq ""){
			for ($residue = $i-1; $residue >= $i-5; $residue--){
#print "$i\t$SSstate[$i]\t$residue\t$SSstate[$residue]\n";
				if ($SSstate[$residue] ne "C"){
					$flag = 1;
				}
			}
			if ($flag == 0){
				push @start_end, "s".($i-5);
			}
		}
		if ($i == 5 && $length > 1 && $start_end[-1] =~ /e/){
			for ($residue = $i-1; $residue >= $i-5; $residue--){
				if ($SSstate[$residue] ne "C"){
					$flag = 1;
				}
			}
			if ($flag == 0){
				push @start_end, "s".($i-5);
			}
		}
		#only push if no overlap of SS spans
		if ($length > 1 && $i > $end_before + 5 && $i>5 && $start_end[-1] =~ /e/){
			for ($residue = $i-1; $residue >= $i-5; $residue--){
				if ($SSstate[$residue] ne "C"){
					$flag = 1;
				}
			}
			if ($flag == 0){
				push @start_end, "s".($i-5);
			}
		}
	}
	#write end of SS span into array
	if ($i > 0 && $SSstate[$i-1] ne $SSstate[$i] && $SSstate[$i-1] ne "C"){
		if ($length > 1 && $start_end[-1] =~ /s/){
			for ($residue = $i; $residue <= $i+4; $residue++){
				if ($SSstate[$residue] ne "C"){
					$flag = 1;
				}
			}
			if ($flag == 0){
				push @start_end, "e".($i+4);
			}
		}
	}

	if ($start_end[-1] =~ /s/ && $flag == 1){
#		pop @start_end;
	}

	$length[$i] = $length;
}
print "@start_end\n";
#write iterator
$j = 0;		#counter in array @start_end, is twice the number of spans
$iter = -1;	#iterator that increases till half of span, then decreases
foreach $i (0..$#SSstate){
	#get length and total number of SSs
	if ($start_end[$j] =~ $i && $start_end[$j] =~ /s/){
		$start = $start_end[$j];
		$start =~ s/s//;
		$end = $start_end[$j+1];
		$end =~ s/e//;
		$length = $end-$start+1;
		$length > 0 ? $total_SSEs[$length]++ : print "";
	}

	#write iterator
	if ($i >= $start && $i < ($start + 0.5* $length)){	
		$iter++;
	}
	elsif ($i > ($start + 0.5* $length) && $i <= $end){	
		$iter--;
	}
	elsif ($i == ($start + 0.5* $length) && $length%2 == 1){
		$iter++;
	}
	elsif ($i == ($start + 0.5* $length) && $length%2 == 0){
	}
	else {
		$iter = -1;
	}

	#match SSstates at the beginning
	if ($iter == 0 && $SSstate[$i+1] ne "C" && $SSPred[$i] eq $SSstate[$i+1]){
		$correct_SSPred[$length][$iter]++;
	}
	#match SSstates at the end
	elsif ($iter == 0 && $SSstate[$i-1] ne "C" && $SSPred[$i] eq $SSstate[$i-1]){
		$correct_SSPred[$length][$iter]++;
	}
	#match SSstates in the center
	elsif ($iter > 0 && $SSPred[$i] eq $SSstate[$i]){
		$correct_SSPred[$length][$iter]++;
	}

	#jump to next SS
	if ($i == $end){
		$j += 2;
	}
print "$SSstate[$i]\t$SSPred[$i]\t$i\t$j\t$length\t$start\t$end\t$iter\n";
}
die;
#go through SSElength
foreach $SSElength (1..81){
	print "$SSElength\t$total_SSEs[$SSElength]\t";
	#print counts for each position in SSEs and divide by total counts times 2, since mirrored
	foreach $iterator (0..(($SSElength-1)/2)){
#print "$iterator\t".(($SSElength-1)/2)."\t";
#print "$iterator\t";
		next if $total_SSEs[$SSElength] == 0;
		#multiply center element by two for odd residue SSEs, since only counted once and not twice as the other positions
		if ($SSElength%2 == 1 && $iterator == (($SSElength-1)/2)){
			$correct_SSPred[$SSElength][$iterator] *= 2;
		}
		print "$correct_SSPred[$SSElength][$iterator]\t";
#		printf "%5.2f\t", $correct_SSPred[$SSElength][$iterator]/($total_SSEs[$SSElength]*2);
	}
	print "\n";
}

