#!/usr/bin/perl 

$dataset = $ARGV[0];	#starts at 1

$in_file = "/home/koehlej/projects/jufo/039_training_9D/descriptors/descriptors".$dataset."_unbal_nonrand_nogaps.dat";
$pred_file = "/home/koehlej/projects/jufo/039_training_9D/octopus_ds".$dataset.".octo_topo";
#$in_file = "/home/koehlej/projects/jufo/039_training_9D/test41-desc.in";
#$pred_file = "/home/koehlej/projects/jufo/039_training_9D/test49-octo.in";

#read the descriptor input file
#save the TM state
$lc = 0;
open (IN, $in_file) || die "cannot open input file $in_file\n";
while ($in = <IN>){
	chomp $in;
	$lc++;
	$in =~ s/^\s+//;

	#only looks at lines that define output state
	next unless ($lc > 2 && $lc%7==2);
	@in = split /\s+/, $in;

	#turn output 9D state into TMstate
	foreach $i (0..8){
		$in[$i] == 1 && $i<3 ? $TMstate = "TM" : 
		$in[$i] == 1 && $i>=3 && $i<=5 ? $TMstate = "TR" :
		$in[$i] == 1 && $i>5 ? $TMstate = "SO" : print "";
	}

	#write into array
	push @TMstate, $TMstate;
}
close IN;

#read the Octopus prediction file
open (PRED, $pred_file) || die "cannot open input file $pred_file\n";
while ($in = <PRED>){
	chomp $in;
	$in =~ s/^\s+//;
	@in = split /\s+/, $in;

	#get TMPrediction
	$TMPred = $in[1];
	push @TMPred, $TMPred;
}
close PRED;

#initialize matrices with zero counts, 81 because longest TM is 81 residues long
foreach $length (1..81){
	foreach $iter (0..$length){
		$correct_TMPred[$length][$iter] = 0;
	}
}

#read both arrays: TMstate, TMPred
foreach $i (0..$#TMstate){
	#get end of TM span before
	$end_before = $start_end[-1];
	$end_before =~ s/e//;

	#write array with start and end of TM spans
	if ($TMstate[$i-1] ne $TMstate[$i] && $TMstate[$i] eq "TM"){
		foreach $k ($i..$i+100){
			if ($TMstate[$k] ne "TM" && $TMstate[$k-1] eq "TM"){
				$length = $k - $i;
				last;
			}
		}
		if ($i == 5 && $length > 7){
			push @start_end, "s".($i-5);
		}
		#only push if no overlap of TM spans
		if ($length > 7 && $i > $end_before + 5 && $i>5){
			push @start_end, "s".($i-5);
		}
	}
	#write end of TM span into array
	if ($i > 0 && $TMstate[$i-1] ne $TMstate[$i] && $TMstate[$i-1] eq "TM"){
		if ($length > 7 && $start_end[-1] =~ /s/){
			push @start_end, "e".($i+4);
		}
	}
	$length[$i] = $length;
}


#write iterator
$j = 0;		#counter in array @start_end, is twice the number of spans
$iter = -1;	#iterator that increases till half of span, then decreases
foreach $i (0..$#TMstate){
	#get length and total number of TMs
	if ($start_end[$j] =~ $i && $start_end[$j] =~ /s/){
		$start = $start_end[$j];
		$start =~ s/s//;
		$end = $start_end[$j+1];
		$end =~ s/e//;
		$length = $end-$start+1;
		$length > 0 ? $total_TMs[$length]++ : print "";
	}

	#write iterator
	if ($i >= $start && $i < ($start + 0.5* $length)){	
		$iter++;
	}
	elsif ($i > ($start + 0.5* $length) && $i <= $end){	
		$iter--;
	}
	elsif ($i == ($start + 0.5* $length) && $length%2 == 1){
		$iter++;
	}
	elsif ($i == ($start + 0.5* $length) && $length%2 == 0){
	}
	else {
		$iter = -1;
	}

	#count correct TMs
	if ($iter >= 0 && $TMPred[$i] eq "M"){
		$correct_TMPred[$length][$iter]++;
	}
	#jump to next TM
	if ($i == $end){
		$j += 2;
	}
#print "$TMstate[$i]\t$TMPred[$i]\t$i\t$j\t$length\t$start\t$end\t$iter\n";
}

#go through TMlength
foreach $TMlength (1..51){
	$total_TMs[$TMlength] == 0 ? $total_TMs[$TMlength] = 0.00001 : print "";
	$percent_ends_match = "";
	$percent_ends_match = $ends_match[$TMlength]/$total_TMs[$TMlength]/2*100;
	$total_TMs[$TMlength] == 0.00001 ? $total_TMs[$TMlength] = 0 : print "";
	print "$TMlength\t$total_TMs[$TMlength]\t$ends_match[$TMlength]\t";
#	printf "%5.2f\t", $percent_ends_match;
	#print counts for each position in TMs and divide by total counts times 2, since mirrored
	foreach $iterator (0..(($TMlength-1)/2)){
		next if $total_TMs[$TMlength] == 0;
		#multiply center element by two for odd residue TMs, since only counted once and not twice as the other positions
		if ($TMlength%2 == 1 && $iterator == (($TMlength-1)/2)){
			$correct_TMPred[$TMlength][$iterator] *= 2;
		}
		print "$correct_TMPred[$TMlength][$iterator]\t";
#		printf "%5.2f\t", $correct_TMPred[$TMlength][$iterator]/($total_TMs[$TMlength]*2);
	}
	print "\n";
}

