#!/usr/bin/perl 

$pdbfile = $ARGV[0];
#$pdbfile = "1AFObcl.pdb";
$pdb = $pdbfile;
$pdb =~ s/database_MPs\///;
$pdb =~ s/$\.pdb//;
$membrane_thickness = 12.5;
$transition_thickness = 12.5;

$out = $pdb.".py";

if ($ARGV[0] eq ""){
	print OUT"\nwrites a pymol script that colors the membrane red, transition white, solution blue\n";
	print OUT"\nusage:\n";
	print OUT"\tcheck_pdb_for_membrane_position.pl <full path of PDB file> \n\n";
}
else{

	open (PDB, $pdbfile) || die "cannot open PDB file $pdbfile\n";
	while ($in = <PDB>){
		chomp $in;
		next unless $in =~ /^ATOM/ && $in =~ CA;
		@in = split //, $in;
		$seqid = "";
		push @chain, $in[21];
		foreach $i (22..25){
			$seqid .= $in[$i];
		}
		$seqid =~ s/\s+//;
		push @seqid, $seqid;

		$z_coord = "";
		foreach $i (46..53){
			$z_coord .= $in[$i];
		}
		$z_coord =~ s/\s+//;
		push @z_coord, $z_coord;
	}
	close PDB;

	open (OUT, ">".$out) || die "cannot open pymol output file $out\n";
	print OUT "bg_color white\n";
	print OUT "set orthoscopic=0\n";
	print OUT "set depth_cue=1\n";
	print OUT "set ray_shadows=0\n";
	print OUT "set direct, 0.5\n\n";
	print OUT "load $pdbfile, $pdb\n";
	print OUT "hide all\n";
	print OUT "color blue, $pdb\n";
	print OUT "set_view (\\
     0.999444425,    0.006301597,    0.032717615,\\
     0.032508094,    0.030959809,   -0.998990893,\\
    -0.007308172,    0.999501169,    0.030737476,\\
    -0.000000129,    0.000014961, -331.943878174,\\
    -0.943946183,   -0.041751988,   33.270534515,\\
   258.050537109,  405.837219238,    0.000000000 )\n";
	foreach $i (0..$#seqid){
#TR
		if ($z_coord[$i] > -($membrane_thickness+$transition_thickness) && $z_coord[$i] < ($membrane_thickness+$transition_thickness)){
			print OUT "color white, (c;$chain[$i] and i;$seqid[$i])\n";
		}
#TM
		if ($z_coord[$i] > -$membrane_thickness && $z_coord[$i] < $membrane_thickness){
			print OUT "color red, (c;$chain[$i] and i;$seqid[$i])\n";
		}
	}
	print OUT "show cartoon, all\n";
	print OUT "center\nzoom\n";
}
system("pymol $out &\n");
