#!/usr/bin/perl 

$listfile = $ARGV[0];	#containing /sb/meiler/PISCES/data/u1/1u19biobcl.pdb
$flag = $ARGV[1];
$out = "check_database_for_membrane_position".$flag.".py";

open (LIST, $listfile) || die "cannot open PDB file $pdbfile\n";
while ($in = <LIST>){
	chomp $in;
	push @pdblist, $in;
}
close LIST;

open (OUT, ">".$out) || die "cannot open pymol output file $out\n";
print OUT "bg_color white\n";
print OUT "set orthoscopic=0\n";
print OUT "set depth_cue=1\n";
print OUT "set ray_shadows=0\n";
print OUT "set direct, 0.5\n\n";
close OUT;

foreach $pdbfile (@pdblist){
#	$pdbfile = "1AFObcl.pdb";
#	$pdb = substr($pdbfile, 26, 4);
	$pdb = $pdbfile;
	$pdb =~ s/database_MPs\///;
	$pdb =~ s/$\.pdb//;
	$membrane_thickness = 12.5;
	$transition_thickness = 12.5;

	@chain = @seqid = @z_coord = ();

	if ($ARGV[0] eq ""){
		print OUT"\nwrites a pymol script that colors the membrane red, transition white, solution blue\n";
		print OUT"\nusage:\n";
		print OUT"\trun_SS.pl <full path of PDB file> \n\n";
	}
	else{

		open (PDB, "database_MPs/".$pdbfile) || die "cannot open PDB file ".$pdbfile."\n";
		while ($in = <PDB>){
			chomp $in;
			next unless $in =~ /^ATOM/ && $in =~ CA;
			@in = split //, $in;
			$seqid = "";
			push @chain, $in[21];
			foreach $i (22..25){
				$seqid .= $in[$i];
			}
			$seqid =~ s/\s+//;
			push @seqid, $seqid;

			$z_coord = "";
			foreach $i (46..53){
				$z_coord .= $in[$i];
			}
			$z_coord =~ s/\s+//;
			push @z_coord, $z_coord;
		}
		close PDB;

		open (OUT, ">>".$out) || die "cannot open pymol output file $out\n";
		print OUT "load database_MPs/$pdbfile, $pdb\n";
		print OUT "hide all\n";
		print OUT "color blue, $pdb\n";
		foreach $i (0..$#seqid){
#TM
			if ($z_coord[$i] > -$membrane_thickness && $z_coord[$i] < $membrane_thickness){
				print OUT "color red, ($pdb and c;$chain[$i] and i;$seqid[$i])\n";
			}
#TR
			elsif ($z_coord[$i] > -($membrane_thickness+$transition_thickness) && $z_coord[$i] < ($membrane_thickness+$transition_thickness)){
				print OUT "color white, ($pdb and c;$chain[$i] and i;$seqid[$i])\n";
			}
		}
		print OUT "show cartoon, all\n";
		print OUT "center\nzoom\n";
	}
}
#system("pymol $out &");
