#!/usr/bin/perl

#$fastalist = "fastalist_dball1.ls";	#chains file
$fastalist = "fastalist_redo.ls";	#chains file
#$fastalist = "current_all_5_different_folds_corrected_lc.ls";
$in_dir = "/home/koehlej/projects/jufo/039_training_9D/database_all/";	#location of fasta files
$html_dir = "/home/koehlej/projects/jufo/039_training_9D/html/";	#directory to print out html files
$out_dir = "/home/koehlej/projects/jufo/039_training_9D/database_all/";	#directory to print output files

print "\nruns SPOCTOPUS for $fastalist\n";

#open fastalist and write protein IDs into an array
open (LIST, $fastalist) || die "cannot open fasta list\n";
while ($list = <LIST>){
	chomp $list;
	push @fastalist, $list;
}
close LIST;

print "$fastalist contains ".($#fastalist+1)." fastas\n\n";

#open fasta files and save the header and the sequence
$cnt = 0;
foreach $fasta (@fastalist){
	$cnt++;
	$sequence = "";
	print "$fasta\n";
	open (FASTA, $in_dir.$fasta.".fasta") || print "=====CANNOT OPEN FASTA FILE ".$in_dir.$fasta."fasta=====";
	while ($in = <FASTA>){
		chomp $in;
		if ($in =~ /^\>/){
			$header = $in;
		}
		else {
			$sequence .= $in;
		}
	}
	close FASTA;
	print "\tfasta reading done\n";

	#run the octopus submission script for these sequences and write out results webpage
	print "015_octopus_submit.pl --sequence=$sequence > ".$html_dir.$fasta.".html\n\n";
	system ("015_octopus_submit.pl --sequence=$sequence > ".$html_dir.$fasta.".html\n\n");
	print "\tsubmitted fasta to OCTOPUS server\n";

	#open results webpage
	open (HTML, $html_dir.$fasta.".html") || print "cannot open ".$html_dir.$fasta.".html\n";	
	while ($in = <HTML>){
		chomp $in;
		#look for string to find the output and create the path where the output is located
		if ($in =~ /topology prediction/){
			@in = split /\"/, $in;
			$html_topology = "http://octopus.cbr.su.se/".$in[1];
			$html_ANNoutput = "http://octopus.cbr.su.se/".$in[3];
		}
	}
	close HTML;
	print "\tOCTOPUS server done for fasta\n";

	#download output
	system ("wget $html_topology -o ".$out_dir.$fasta."_octo_topo.log -O ".$out_dir.$fasta.".octo_topo\n");
	system ("wget $html_ANNoutput -o ".$out_dir.$fasta."_octo_ANN.log -O ".$out_dir.$fasta.".octo_ANN\n");
	print "\tresults downloaded\n";

	#cleanup
	print "\tcleanup\n";
	system ("rm ".$out_dir.$fasta."*octo*log ".$out_dir.$fasta.".octo_ANN\n");
	system ("rm ".$html_dir.$fasta.".html\n");
	
	#print counter to see progress
	print "$cnt fasta file(s) done\n";
}
print "\n";
