#!/usr/bin/perl

$fastalist = "fastalist_dball.ls";	#chains file
#$fastalist = "current_all_5_different_folds_corrected_lc.ls";
$in_dir = "/home/koehlej/projects/jufo/039_training_9D/database_all/";	#location of fasta files
$html_dir = "/home/koehlej/projects/jufo/039_training_9D/html_tmbetanet/";	#directory to print out html files
$out_dir = "/home/koehlej/projects/jufo/039_training_9D/database_all/";	#directory to print output files

print "\nruns TMBETA-NET for $fastalist\n";

#open fastalist and write protein IDs into an array
open (LIST, $fastalist) || die "cannot open fasta list\n";
while ($list = <LIST>){
	chomp $list;
	push @fastalist, $list;
}
close LIST;

print "$fastalist contains ".($#fastalist+1)." fastas\n\n";

#open fasta files and save the header and the sequence
$cnt = 0;
foreach $fasta (@fastalist){
	$cnt++;
	$sequence = "";
	print "$fasta\n";
	open (FASTA, $in_dir.$fasta.".fasta") || print "=====CANNOT OPEN FASTA FILE ".$in_dir.$fasta."fasta=====";
	while ($in = <FASTA>){
		chomp $in;
		if ($in =~ /^\>/){
			$header = $in;
		}
		else {
			$sequence .= $in;
		}
	}
	close FASTA;
	print "\tfasta reading done\n";

	#run the octopus submission script for these sequences and write out results webpage
	print "017_tmbetanet_submit.pl --sequence=$sequence > ".$html_dir.$fasta.".html\n\n";
	system ("017_tmbetanet_submit.pl --sequence=$sequence > ".$html_dir.$fasta.".html\n\n");
	print "\tsubmitted fasta to TMBETA-NET server\n";
	print "\tTMBETA-NET server done for fasta\n";
	print "\tresults downloaded\n";

	#open results webpage
	open (HTML, $html_dir.$fasta.".html") || print "cannot open ".$html_dir.$fasta.".html\n";	
	open (OUT, ">".$out_dir.$fasta.".tmbetanet") || die "cannot open output file ".$out_dir.$fasta.".tmbetanet\n";
	while ($in = <HTML>){
		chomp $in;
		#look for string to find the output and create the path where the output is located
		if ($in =~ /Segment/){
			@in = split /\:/, $in;
			@in1 = split /to/, $in[1];
			$start = $in1[0];
			$start =~ s/\s+//g;
			$start_res = substr($start, 0, 1);
			$start_resid = substr($start, 1);
			$end = $in1[1];
			$end =~ s/\s+//g;
			$end_res = substr($end, 0, 1);
			$end_resid = substr($end, 1);
			print OUT "tm\t$start_resid\t$end_resid\n";
		}
	}
	close HTML;
	close OUT; 
	print "\tresults converted\n";

	#cleanup
	print "\tcleanup\n";
	system ("rm ".$html_dir.$fasta.".html\n");
	
	#print counter to see progress
	print "$cnt fasta file(s) done\n";
}
print "\n";
