#!/usr/bin/perl

$fastalist = $ARGV[0];	#chains file
$in_dir = "database_all/";		#location of fasta files
$html_dir = "TMkink_output/";		#directory to print out html files
$out_dir = "TMkink_output/";		#directory to print output files

if ($ARGV[0] eq ""){
	print "\nruns TMkink for $fastalist\n";
}
else{

	#open fastalist and write protein IDs into an array
	open (LIST, $fastalist) || die "cannot open fasta list\n";
	while ($list = <LIST>){
		chomp $list;
		push @fastalist, $list;
	}
	close LIST;

	print "$fastalist contains ".($#fastalist+1)." fastas\n\n";

	#open fasta files and save the header and the sequence
	$cnt = 0;
	foreach $fasta (@fastalist){
		$cnt++;
		$sequence = "";
		print "$fasta\n";
		open (FASTA, $in_dir.$fasta.".fasta") || print "=====CANNOT OPEN FASTA FILE ".$in_dir.$fasta.".fasta=====";
		while ($in = <FASTA>){
			chomp $in;
			if ($in =~ /^\>/){
				$header = $in;
			}
			else {
				$sequence .= $in;
			}
		}
		close FASTA;
		print "\tfasta reading done\n";

		#run the TMkink submission script for these sequences and write out results webpage
		print "057_TMkink_submit.pl --job_identifier=$fasta --sequence=$sequence --email=julia.koehler1982\@gmail.com > ".$html_dir.$fasta.".html\n\n";
		system ("057_TMkink_submit.pl --job_identifier=$fasta --sequence=$sequence --email=julia.koehler1982\@gmail.com > ".$html_dir.$fasta.".html\n\n");
		print "\tsubmitted fasta $fasta to TMkink server\n";
		sleep 60;

		#open results webpage
#		open (HTML, $html_dir.$fasta.".html") || print "cannot open ".$html_dir.$fasta.".html\n";	
#		while ($in = <HTML>){
#			chomp $in;
			#look for string to find the output and create the path where the output is located
#			if ($in =~ /Thank you for your submission./){
#				@in = split /\"/, $in;
#				$html_topology = "http://services.mbi.ucla.edu/tmkinkpredictor/results/".$in[9]."_F.html";
#			}
#		}
#		close HTML;
#		print "\twaiting for TMkink server...\n";

#		sleep 120;

		#download output
#		print "wget $html_topology -o ".$out_dir.$fasta."_TMkink.log -O ".$out_dir.$fasta.".tmkink\n";
#		system ("wget $html_topology -o ".$out_dir.$fasta."_TMkink.log -O ".$out_dir.$fasta.".tmkink\n");
#		print "\tresults downloaded\n";

		#cleanup
#		print "\tcleanup\n";
#		system ("rm ".$out_dir.$fasta."*TMkink*log\n");
#		system ("rm ".$html_dir.$fasta.".html\n");
	
		#print counter to see progress
#		print "$cnt fasta file(s) done\n";
	}
#	print "find <protein>.TMkink files in this directory\n";
}
